// (C) 2001-2021 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

//`default_nettype none

module intel_pcie_ptile_avmm_dcore
#(
  parameter bursting_master_address_width_hwtcl = 0,
  parameter pfnum_width_hwtcl                   = 0,
  parameter vfnum_width_hwtcl                   = 0, 
  parameter enable_rx_buffer_limit_ports_hwtcl  = 0,
  parameter txs_data_width_hwtcl                = 0,
  parameter cg_enable_a2p_interrupt_hwtcl       = 0,
  parameter cg_enable_advanced_interrupt_hwtcl  = 0,

// The value type (integer/string) will change based on hw_tcl development.
  parameter enable_lite_avmm_bridge            = 1,
  parameter enable_cpl_ordering_with_64tag_supp_hwtcl = 1,
  parameter enable_write_mover_hwtcl           = 1,
  parameter enable_read_mover_hwtcl            = 1,
  parameter enable_legacy_interrupt_hwtcl      = 0,
  parameter enable_bursting_slave_hwtcl        = 1,
  parameter enable_bursting_master_hwtcl       = 1,
  parameter enable_sriov_hwtcl                 = 0,
  parameter enable_root_port_hwtcl             = 0,
  parameter bursting_slave_address_width_hwtcl = 64,
  parameter read_mover_address_width_hwtcl     = 32,
  parameter write_mover_address_width_hwtcl    = 32,
  parameter enable_config_slave_hwtcl          = 1,
  parameter config_slave_address_width_hwtcl   = 29,
  parameter virtual_maxpayload_size_hwtcl      = 512,
  parameter en_order_rx_posted_cpl_hwtcl       = 1,
  parameter payload_width_integer_hwtcl        = 256 ,
  parameter hdr_width_integer_hwtcl            = 256 ,
  parameter pfx_width_integer_hwtcl            = 64  ,
  parameter double_width_integer_hwtcl         = 1   ,
  parameter total_pf_count_hwtcl               = 4 ,
  parameter total_pf_count_width_hwtcl         = 2 ,
  parameter total_vf_count_hwtcl               = 0 ,
  parameter total_vf_count_width_hwtcl         = 1 ,

  // Internal parameters, not user visible
  parameter device_family                    = "Stratix 10",
  parameter PFNUM                            = total_pf_count_hwtcl,
  parameter PFNUM_WIDTH                      = total_pf_count_width_hwtcl,
  parameter VFNUM_WIDTH                      = total_vf_count_width_hwtcl,
  parameter SIMULATION_SPEEDUP               = 0,
//not used
  parameter                                                 ENABLE_ECC                                                  = "FALSE",
  parameter                                                 TXHIP_CDTS_LATENCY                                          = 29,          // Maximum latency between np pkt injection and credit update
  parameter                                                 ROOT_PORT                                                   = 0,           // Indicating Rootport
  parameter                                                 TL_CFG_ADD_WIDTH                                            = 5,           // C2E 4, C2P 5

  parameter                                                 virtual_link_rate                                           = "gen3",
  parameter                                                 virtual_link_width                                          = "x8",
  parameter                                                 enable_a2p_interrupt_hwtcl                                  = 0,
  parameter                                                 enable_advanced_interrupt_hwtcl                             = 0,

  parameter                                                 dma_enabled_hwtcl                                           = 1,           // 0 - not enabled,  1 - enabled
  parameter                                                 dma_instantiate_controller_hwtcl                            = 1,           // 0 - not enabled,  1 - enabled
  parameter                                                 avmm_addr_width_hwtcl                                       = 32,          // 32(address translation enabled) or 64
  parameter                                                 txs_enabled_hwtcl                                           = 1,           // 0 - not enabled,  1 - enabled
  parameter                                                 txs_address_width_hwtcl                                     = 32,

  parameter                                                 hptxs_enabled_hwtcl                                         = 1,           // 0 - not enabled,  1 - enabled
  parameter                                                 hptxs_enabled_mapping_hwtcl                                 = 0,           // 0 - not enabled,  1 - enabled
  parameter                                                 hptxs_address_width_hwtcl                                   = 25,          // user specified, otherwise must be the sum of the following two parameters.
  parameter                                                 hptxs_address_translation_table_address_width_hwtcl         = 9,           // [0-9] are allowed. e.g. 9:512 entries
  parameter                                                 hptxs_address_translation_window_address_width_hwtcl        = 16,          // [12-(64-hptxs_address_translation_table_address_width_hwtcl)] are allowed. e.g. 12:4KB window //AA 12 currently not supported.


  parameter                                                 pf0_bar0_enable_rxm_burst_hwtcl                             = 0,
  parameter                                                 pf0_bar1_enable_rxm_burst_hwtcl                             = 0,
  parameter                                                 pf0_bar2_enable_rxm_burst_hwtcl                             = 0,
  parameter                                                 pf0_bar3_enable_rxm_burst_hwtcl                             = 0,
  parameter                                                 pf0_bar4_enable_rxm_burst_hwtcl                             = 0,
  parameter                                                 pf0_bar5_enable_rxm_burst_hwtcl                             = 0,

  // PCIe HIP AST parameters
  parameter                                                 pf0_bar0_address_width_hwtcl                                = 1,
  parameter                                                 pf0_bar1_address_width_hwtcl                                = 1,
  parameter                                                 pf0_bar2_address_width_hwtcl                                = 1,
  parameter                                                 pf0_bar3_address_width_hwtcl                                = 1,
  parameter                                                 pf0_bar4_address_width_hwtcl                                = 1,
  parameter                                                 pf0_bar5_address_width_hwtcl                                = 1,

  parameter                                                 pf0_pci_type0_bar0_enabled                                  = "enable",
  parameter                                                 pf0_pci_type0_bar1_enabled                                  = "enable",
  parameter                                                 pf0_pci_type0_bar2_enabled                                  = "enable",
  parameter                                                 pf0_pci_type0_bar3_enabled                                  = "enable",
  parameter                                                 pf0_pci_type0_bar4_enabled                                  = "enable",
  parameter                                                 pf0_pci_type0_bar5_enabled                                  = "enable",

  parameter                                                 pf0_bar0_type                                               = "pf0_bar0_mem32",
  parameter                                                 pf0_bar1_type                                               = "pf0_bar1_mem32",
  parameter                                                 pf0_bar2_type                                               = "pf0_bar2_mem32",
  parameter                                                 pf0_bar3_type                                               = "pf0_bar3_mem32",
  parameter                                                 pf0_bar4_type                                               = "pf0_bar4_mem32",
  parameter                                                 pf0_bar5_type                                               = "pf0_bar5_mem32", 
  parameter                                                 enable_x8_mode                                              =  (payload_width_integer_hwtcl == 256)? 1:0     
)
(
  // clock and reset
  input                                           clk,
  input                                           rst_n, // might make a multi-bit signal to generate a reset tree
  input                                           pin_perst_n,
  
  output logic                                    reset_status_n,
  output logic                                    app_clk,

  // Interface to the Streaming ports of HIP.
  //RX Ports
  output logic                                                              rx_st_ready_o,
  input logic [double_width_integer_hwtcl? 1:0:0]                           rx_st_valid_i,
  input logic [double_width_integer_hwtcl? 1:0:0]                           rx_st_sop_i,
  input logic [double_width_integer_hwtcl? 1:0:0]                           rx_st_eop_i,
  input logic [hdr_width_integer_hwtcl-1:0]                                 rx_st_hdr_i,
  input logic [payload_width_integer_hwtcl-1:0]                             rx_st_data_i,
  input logic [double_width_integer_hwtcl? 1:0:0]                           rx_st_vf_active_i,
  input logic [double_width_integer_hwtcl*3-1:0]                            rx_st_func_num_i,
  input logic [double_width_integer_hwtcl*11-1:0]                           rx_st_vf_num_i,
  input logic [double_width_integer_hwtcl? 5:2:0]                           rx_st_bar_range_i,
  input logic                                                               rx_par_err_i,

  //TX Ports
  input logic                                       tx_st_ready_i,
  input logic                                       tx_par_err_i,
  output logic [double_width_integer_hwtcl? 1:0:0]  tx_st_valid_o,
  output logic [double_width_integer_hwtcl? 1:0:0]  tx_st_sop_o,
  output logic [double_width_integer_hwtcl? 1:0:0]  tx_st_eop_o,
  output logic [double_width_integer_hwtcl? 1:0:0]  tx_st_err_o,
  output logic [hdr_width_integer_hwtcl-1:0]        tx_st_hdr_o,
  output logic [payload_width_integer_hwtcl-1:0]    tx_st_data_o,
  output logic [double_width_integer_hwtcl? 1:0:0]  tx_st_vf_active_o,

  //missing in 512_dcore:
input  logic [double_width_integer_hwtcl*3 -1 :0]   rx_st_empty_i,
input  logic [pfx_width_integer_hwtcl-1:0]          rx_st_tlp_prfx_i,
input  logic [double_width_integer_hwtcl -1:0]         rx_st_tlp_abort_i,
input  logic [payload_width_integer_hwtcl/8-1:0]    rx_st_data_par_i,
input  logic [hdr_width_integer_hwtcl/8-1:0]        rx_st_hdr_par_i,
input  logic [pfx_width_integer_hwtcl/8-1:0]    rx_st_tlp_prfx_par_i,

output  logic [pfx_width_integer_hwtcl-1:0]    tx_st_tlp_prfx_o,
output  logic [payload_width_integer_hwtcl/8-1:0]    tx_st_data_par_o,
output  logic [hdr_width_integer_hwtcl/8-1:0]    tx_st_hdr_par_o,
output  logic [pfx_width_integer_hwtcl/8-1:0]tx_st_tlp_prfx_par_o,
input dl_timer_update_o,
  // Streaming Packets HIP Credit Interface.
  // TX Ports
  input logic [15:0]                              tx_cdts_limit_i,           //C2p NA      C2e  NA             WHR [15:0]
  input logic [2:0]                               tx_cdts_limit_tdm_idx_i,   //C2p NA      C2e  NA             WHR [2:0]

  // RX Ports
  output logic [11:0]                             rx_buffer_limit_o,         //C2p NA      C2e  NA             WHR [11:0]
  output logic [1:0]                              rx_buffer_limit_tdm_idx_o, //C2p NA      C2e  NA             WHR [1:0]


  // HIP Misc interface
  // Config Interface
  // Lukas to update the interface name
  input logic [2:0]                               tl_cfg_func_i,               //C2p[1:0]    C2e  [1:0]          WHR [2:0]
  input logic [4:0]                               tl_cfg_add_i,                //C2p[4:0]    C2e  [3:0]          WHR [4:0]
  input logic [31:0]                              tl_cfg_ctl_i,                //C2p[31:0]   C2e  [31:0]         WHR [15:0]

  output logic [2:0]                              tl_cfg_func_o,               //C2p[1:0]    C2e  [1:0]          WHR [2:0]
  output logic [4:0]                              tl_cfg_add_o,                //C2p[4:0]    C2e  [3:0]          WHR [4:0]
  output logic [31:0]                             tl_cfg_ctl_o,                //C2p[31:0]   C2e  [31:0]         WHR [15:0]

  // Information extracted from tl_cfg
  input logic [2:0]                               mps_i,
  input logic [2:0]                               mrrs_i,
  input logic [PFNUM-1:0]                         bus_master_enabled_i,

  /* THis port will be removed
  // Information extracted from config space.
  input logic                                     pf0_completion_timeout_valid_i, // Asserted when fresh data is present. // Not used.
  input logic [3:0]                               pf0_completion_timeout_period_i,
  input logic                                     pf0_completion_timeout_disable_i,
  */

  // AVMM Interfaces
  // CS AVMM interface
  output logic                                          cs_waitrequest_o,
  input logic [config_slave_address_width_hwtcl-1:0]    cs_address_i, // [28]:0 : Cfg0 ,1 : Cfg1; [27:0] bit {Bus,Device,Func,Reg}
  input logic [3:0]                                     cs_byteenable_i,
  input logic                                           cs_read_i,
  output logic [31:0]                                   cs_readdata_o,
  output logic                                          cs_readdatavalid_o,
  input logic                                           cs_write_i,
  input logic [31:0]                                    cs_writedata_i,
  output logic                                          cs_writeresponsevalid_o, //used as completion ready
  output logic [1:0]                                    cs_response_o, //Significant when readdatavalid or writeresponsevalid is asserted.00 : OKAY - successful response for a transaction;01 : RESERVED;10 : SLAVEERROR ;11 : DECODEERROR


  //Write data mover AVMM interface
  input logic                                           wrdm_readdatavalid_i,
  input logic [511:0]                                   wrdm_readdata_i,
  input logic [1:0]                                     wrdm_response_i,
  input logic                                           wrdm_waitrequest_i,
  output logic                                          wrdm_vfactive_o,
  output logic [PFNUM_WIDTH-1:0]                        wrdm_pfnum_o,
  output logic [VFNUM_WIDTH-1:0]                        wrdm_vfnum_o,
  output logic                                          wrdm_read_o,
  output logic [write_mover_address_width_hwtcl-1:0]    wrdm_address_o,
  output logic [3:0]                                    wrdm_burstcount_o,
  output logic [63:0]                                   wrdm_byteenable_o,

  //Read data mover AVMM interface
  output logic [511:0]                                  rddm_writedata_o,
  output logic [63:0]                                   rddm_byteenable_o,
  output logic [3:0]                                    rddm_burstcount_o,
  output logic [read_mover_address_width_hwtcl-1:0]     rddm_address_o,
  output logic                                          rddm_write_o,
  input logic                                           rddm_waitrequest_i,
  output logic                                          rddm_vfactive_o,
  output logic [PFNUM_WIDTH-1:0]                        rddm_pfnum_o,
  output logic [VFNUM_WIDTH-1:0]                        rddm_vfnum_o,


  //Bursting Master AVMM Interface
  input logic                                     bam_readdatavalid_i,
  input logic [511:0]                             bam_readdata_i,
  input logic [1:0]                               bam_response_i,
  input logic                                     bam_waitrequest_i,
  input logic                                     bam_writeresponsevalid_i,
  output logic                                    bam_vfactive_o,
  output logic [PFNUM_WIDTH-1:0]                  bam_pfnum_o,
  output logic [VFNUM_WIDTH-1:0]                  bam_vfnum_o,
  output logic                                    bam_read_o,
  output logic                                    bam_write_o,
  // output logic [63:0]                             bam_address_o,
  // Matching Bar Address Interpreter slave width
  output logic [59:0]                             bam_address_o,
  output logic [3:0]                              bam_burstcount_o,
  output logic [63:0]                             bam_byteenable_o,
  output logic [2:0]                              bam_bar_o,
  output logic [511:0]                            bam_writedata_o,

  //Bursting Slave AVMM Interface
  input logic                                           bas_vfactive_i,
  input logic [PFNUM_WIDTH-1:0]                         bas_pfnum_i,
  input logic [VFNUM_WIDTH-1:0]                         bas_vfnum_i,
  input logic [bursting_slave_address_width_hwtcl-1:0]  bas_address_i,
  input logic [63:0]                                    bas_byteenable_i,
  input logic                                           bas_read_i,
  input logic                                           bas_write_i,
  input logic [511:0]                                   bas_writedata_i,
  input logic [3:0]                                     bas_burstcount_i,
  output logic                                          bas_waitrequest_o,
  output logic [511:0]                                  bas_readdata_o,
  output logic                                          bas_readdatavalid_o,
  output logic [1:0]                                    bas_response_o, 

  // Bus Master Enabled
  output logic [PFNUM_WIDTH-1:0]                  bus_master_enable_o, 

  // DMA Controller Interface
  // Write data mover interface
  input logic                                     wrdm_desc_valid_i,
  input logic [1+VFNUM_WIDTH+PFNUM_WIDTH+159:0]   wrdm_desc_data_i,
  output logic                                    wrdm_desc_ready_o,

  input logic                                     wrdm_prio_valid_i,
  input logic [1+VFNUM_WIDTH+PFNUM_WIDTH+159:0]   wrdm_prio_data_i,
  output logic                                    wrdm_prio_ready_o,

  output logic [1+VFNUM_WIDTH+PFNUM_WIDTH+18-1:0] wrdm_tx_data_o,
  output logic                                    wrdm_tx_valid_o,


  // Read data mover interface
  input logic                                     rddm_desc_valid_i,
  input logic [1+VFNUM_WIDTH+PFNUM_WIDTH+159:0]   rddm_desc_data_i,
  output logic                                    rddm_desc_ready_o,

  input logic                                     rddm_prio_valid_i,
  input logic [1+VFNUM_WIDTH+PFNUM_WIDTH+159:0]   rddm_prio_data_i,
  output logic                                    rddm_prio_ready_o,

  output logic [1+VFNUM_WIDTH+PFNUM_WIDTH+18-1:0] rddm_tx_data_o,
  output logic                                    rddm_tx_valid_o

);
  localparam adap_en = (payload_width_integer_hwtcl < 512) ? 1:0;

  logic                                 rx_st_ready_wire;
  logic [1:0]                           rx_st_valid_wire;
  logic [1:0]                           rx_st_eop_wire;
  logic [1:0]                           rx_st_sop_wire;
  logic [256-1:0]                       rx_st_hdr_wire;
  logic [512-1:0]                       rx_st_data_wire;
  logic [1:0]                           rx_st_vf_active_wire;
  logic [PFNUM_WIDTH*2-1:0]             rx_st_func_num_wire;
  logic [VFNUM_WIDTH*2-1:0]             rx_st_vf_num_wire;
  logic [5:0]                           rx_st_bar_range_wire;
  logic                                 rx_par_err_wire;
  logic                                 tx_st_ready_wire;
  logic                                 tx_par_err_wire;
  logic [1:0]                           tx_st_valid_wire;
  logic [1:0]                           tx_st_sop_wire;
  logic [1:0]                           tx_st_eop_wire;
  logic [1:0]                           tx_st_err_wire;
  logic [256-1:0]                       tx_st_hdr_wire;
  logic [512-1:0]                       tx_st_data_wire;
  logic [1:0]                           tx_st_vf_active_wire;

  logic clk_250;
  logic rst_n_clk250,rst_n_clk250_sync;

  logic [15:0]              tx_cdts_limit_wire;
  logic [2:0]               tx_cdts_limit_tdm_idx_wire;
  logic [11:0]              rx_buffer_limit_wire;
  logic [1:0]               rx_buffer_limit_tdm_idx_wire;
  logic [2:0]               tl_cfg_func_wire;
  logic [4:0]               tl_cfg_add_wire;
  logic [31:0]              tl_cfg_ctl_wire;
  logic [2:0]               mps_logic;
  logic [2:0]               mrrs_logic;
  logic [4:0]               device_number;
  logic [255:0]             rx_st_hdr_switch_wire,tx_st_hdr_switch_wire;

  logic  [63:0]             bam_address_wire;

  assign clk_wire                     = (payload_width_integer_hwtcl == 256) ? clk_250 : clk;
  assign app_clk                      = (payload_width_integer_hwtcl == 256) ? clk_250 : clk;
  assign rst_n_wire                   = (payload_width_integer_hwtcl == 256) ? rst_n_clk250 :rst_n;
  
  assign reset_status_n               = rst_n_wire;
  assign rx_st_hdr_switch_wire        = {rx_st_hdr_wire[159:128],rx_st_hdr_wire[191:160],rx_st_hdr_wire[223:192],rx_st_hdr_wire[255:224],
                                         rx_st_hdr_wire[31:0],rx_st_hdr_wire[63:32],rx_st_hdr_wire[95:64],rx_st_hdr_wire[127:96]};
  assign {tx_st_hdr_wire[159:128],tx_st_hdr_wire[191:160],tx_st_hdr_wire[223:192],tx_st_hdr_wire[255:224],
          tx_st_hdr_wire[31:0],tx_st_hdr_wire[63:32],tx_st_hdr_wire[95:64],tx_st_hdr_wire[127:96]} = tx_st_hdr_switch_wire;
  assign tx_st_tlp_prfx_o = '0;

  assign tl_cfg_func_o             = tl_cfg_func_wire             ;
  assign tl_cfg_add_o              = tl_cfg_add_wire              ;
  assign tl_cfg_ctl_o              = tl_cfg_ctl_wire              ;
  assign bam_address_o             = bam_address_wire[59:0]       ;
  
  generate
    if (payload_width_integer_hwtcl == 512 ) begin
      assign rx_st_ready_o        = rx_st_ready_wire;
      assign rx_st_valid_wire     = rx_st_valid_i;
      assign rx_st_sop_wire       = rx_st_sop_i;
      assign rx_st_eop_wire       = rx_st_eop_i;
      assign rx_st_hdr_wire       = rx_st_hdr_i;
      assign rx_st_data_wire      = rx_st_data_i;
      assign rx_st_vf_active_wire = rx_st_vf_active_i;
      assign rx_st_func_num_wire  = {rx_st_func_num_i[3+PFNUM_WIDTH-1:3] , rx_st_func_num_i[PFNUM_WIDTH-1:0]};
      assign rx_st_vf_num_wire    = {rx_st_vf_num_i[11+VFNUM_WIDTH-1:0], rx_st_vf_num_i[VFNUM_WIDTH-1:0]};
      assign rx_st_bar_range_wire = rx_st_bar_range_i;
      assign rx_par_err_wire      = rx_par_err_i;
      assign tx_st_ready_wire     = tx_st_ready_i;
      assign tx_par_err_wire      = tx_par_err_i;
      assign tx_st_valid_o        = tx_st_valid_wire;
      assign tx_st_sop_o          = tx_st_sop_wire;
      assign tx_st_eop_o          = tx_st_eop_wire;
      assign tx_st_err_o          = tx_st_err_wire;
      assign tx_st_hdr_o          = tx_st_hdr_wire;
      assign tx_st_data_o         = tx_st_data_wire;
      assign tx_st_vf_active_o    = tx_st_vf_active_wire;

      //assign tx_cdts_limit_wire           = tx_cdts_limit_i           ;
      //assign tx_cdts_limit_tdm_idx_wire   = tx_cdts_limit_tdm_idx_i   ;
      assign rx_buffer_limit_o            = rx_buffer_limit_wire;
      assign rx_buffer_limit_tdm_idx_o    = rx_buffer_limit_tdm_idx_wire;      
      
      assign tl_cfg_func_wire             = tl_cfg_func_i             ;
      assign tl_cfg_add_wire              = tl_cfg_add_i              ;
      assign tl_cfg_ctl_wire              = tl_cfg_ctl_i              ;
    end
    if (payload_width_integer_hwtcl > 128 ) begin
      always @ (posedge clk_wire or negedge rst_n_wire) begin
        if (!rst_n_wire) begin
          device_number <= '0;
          mps_logic  <=  '0;
          mrrs_logic <= '0;
          bus_master_enable_o <= '0;
        end
        else begin
          if (tl_cfg_func_wire == 3'b000 && tl_cfg_add_wire == 5'h00) begin
            mps_logic                   <= tl_cfg_ctl_wire[2:0];
            mrrs_logic                  <= tl_cfg_ctl_wire[5:3];
            bus_master_enable_o[0]      <= tl_cfg_ctl_wire[7];
          end
          if (tl_cfg_func_wire == 3'b000 && tl_cfg_add_wire == 5'h01) begin
            device_number <= tl_cfg_ctl_wire[12:8];
          end
          if (PFNUM > 1) begin
            if ((tl_cfg_func_wire == 3'b001 && tl_cfg_add_wire == 5'h00))
              bus_master_enable_o[1] <= tl_cfg_ctl_wire[7];
          end
          if (PFNUM > 2) begin
            if (tl_cfg_func_wire == 3'b010 && tl_cfg_add_wire == 5'h00)
              bus_master_enable_o[2] <= tl_cfg_ctl_wire[7];
          end
          if (PFNUM > 3) begin
            if (tl_cfg_func_wire == 3'b011 && tl_cfg_add_wire == 5'h00)
              bus_master_enable_o[3] <= tl_cfg_ctl_wire[7];
          end
          if (PFNUM > 4) begin
            if (tl_cfg_func_wire == 3'b100 && tl_cfg_add_wire == 5'h00)
              bus_master_enable_o[4] <= tl_cfg_ctl_wire[7];
          end
          if (PFNUM > 5) begin
            if (tl_cfg_func_wire == 3'b101 && tl_cfg_add_wire == 5'h00)
              bus_master_enable_o[5] <= tl_cfg_ctl_wire[7];
          end
          if (PFNUM > 6) begin
            if (tl_cfg_func_wire == 3'b110 && tl_cfg_add_wire == 5'h00)
              bus_master_enable_o[6] <= tl_cfg_ctl_wire[7];
          end
          if (PFNUM > 7) begin
            if (tl_cfg_func_wire == 3'b111 && tl_cfg_add_wire == 5'h00)
              bus_master_enable_o[7] <= tl_cfg_ctl_wire[7];
          end
        end
      end

      if (enable_lite_avmm_bridge == 1 ) begin
        intel_pcie_lite_avmm_bridge_512_dcore
        #(
        // The value type (integer/string) will change based on hw_tcl development.
          .enable_completion_reordering  (enable_cpl_ordering_with_64tag_supp_hwtcl        ),
          .enable_write_mover            (enable_write_mover_hwtcl            ),
          .enable_read_mover             (enable_read_mover_hwtcl             ),
          .enable_legacy_interrupt       (enable_legacy_interrupt_hwtcl       ),
          .enable_bursting_slave         (enable_bursting_slave_hwtcl         ),
          .enable_bursting_master        (enable_bursting_master_hwtcl        ),
          .enable_sriov                  (enable_sriov_hwtcl                  ),
          .enable_root_port              (enable_root_port_hwtcl              ),
          .enable_x8_mode                (enable_x8_mode                      ),
          .bursting_slave_address_width  (bursting_slave_address_width_hwtcl  ),
          .read_mover_address_width      (read_mover_address_width_hwtcl      ),
          .write_mover_address_width     (write_mover_address_width_hwtcl     ),
          .enable_config_slave           (enable_config_slave_hwtcl           ),
          .config_slave_address_width    (config_slave_address_width_hwtcl    ),
          .virtual_maxpayload_size_hwtcl (virtual_maxpayload_size_hwtcl       ),
          .en_order_rx_posted_cpl_hwtcl  (en_order_rx_posted_cpl_hwtcl        ),
          .DEVICE_FAMILY                 (device_family                       ),
          .PFNUM                         (total_pf_count_hwtcl                ),
          .PFNUM_WIDTH                   (total_pf_count_width_hwtcl          ),
          .VFNUM_WIDTH                   (total_vf_count_width_hwtcl          ),
          .SIMULATION_SPEEDUP            (SIMULATION_SPEEDUP                  ),
          .pf0_bar0_address_width_hwtcl  (pf0_bar0_address_width_hwtcl        ),
          .pf0_bar1_address_width_hwtcl  (pf0_bar1_address_width_hwtcl        ),
          .pf0_bar2_address_width_hwtcl  (pf0_bar2_address_width_hwtcl        ),
          .pf0_bar3_address_width_hwtcl  (pf0_bar3_address_width_hwtcl        ),
          .pf0_bar4_address_width_hwtcl  (pf0_bar4_address_width_hwtcl        ),
          .pf0_bar5_address_width_hwtcl  (pf0_bar5_address_width_hwtcl        )
        )
        avmm_512_inst  (
          // clock and reset
          .clk                       (clk_wire),
          .rst_n                     (rst_n_wire),
        
          // Interface to the Streaming ports of HIP.
          //RX Ports
          .rx_st_ready_o                         (rx_st_ready_wire),
          .rx_st_valid_i                         (rx_st_valid_wire),
          .rx_st_sop_i                           (rx_st_sop_wire),
          .rx_st_eop_i                           (rx_st_eop_wire),
          .rx_st_hdr_i                           (rx_st_hdr_switch_wire),
          .rx_st_data_i                          (rx_st_data_wire),
          .rx_st_vf_active_i                     (rx_st_vf_active_wire),
          .rx_st_func_num_i                      (rx_st_func_num_wire),
          .rx_st_vf_num_i                        (rx_st_vf_num_wire),
          .rx_st_bar_range_i                     (rx_st_bar_range_wire),
          .rx_par_err_i                          (rx_par_err_wire),
        
          //TX Ports
          .tx_st_ready_i                         (tx_st_ready_wire),
          .tx_par_err_i                          (tx_par_err_wire),
          .tx_st_valid_o                         (tx_st_valid_wire),
          .tx_st_sop_o                           (tx_st_sop_wire),
          .tx_st_eop_o                           (tx_st_eop_wire),
          .tx_st_err_o                           (tx_st_err_wire),
          .tx_st_hdr_o                           (tx_st_hdr_switch_wire),
          .tx_st_data_o                          (tx_st_data_wire),
          .tx_st_vf_active_o                     (tx_st_vf_active_wire),
        
          // Streaming Packets HIP Credit Interface.
          .tx_cdts_limit_i                       (tx_cdts_limit_wire           ),
          .tx_cdts_limit_tdm_idx_i               (tx_cdts_limit_tdm_idx_wire   ),
          .rx_buffer_limit_o                     (rx_buffer_limit_wire         ),
          .rx_buffer_limit_tdm_idx_o             (rx_buffer_limit_tdm_idx_wire ),
        
        
          // HIP Misc interface
          // Config Interface
          .tl_cfg_func                           (tl_cfg_func_wire),
          .tl_cfg_add                            (tl_cfg_add_wire ),
          .tl_cfg_ctl                            (tl_cfg_ctl_wire ),
        
        
          // Information extracted from tl_cfg
          // Add these to adapter later
          .mps_i                                 (mps_logic                            ),
          .mrrs_i                                (mrrs_logic                           ),
          .bus_master_enabled_i                  (bus_master_enable_o[PFNUM-1:0]  ),
        
          /*   // Information extracted from config space.
          input logic                                     pf0_completion_timeout_valid_i, // Asserted when fresh data is present. // Not used.
          input logic [3:0]                               pf0_completion_timeout_period_i,
          input logic                                     pf0_completion_timeout_disable_i,
        
           */
          .cs_waitrequest_o         (cs_waitrequest_o         ),
          .cs_address_i             (cs_address_i             ),
          .cs_byteenable_i          (cs_byteenable_i          ),
          .cs_read_i                (cs_read_i                ),
          .cs_readdata_o            (cs_readdata_o            ),
          .cs_readdatavalid_o       (cs_readdatavalid_o       ),
          .cs_write_i               (cs_write_i               ),
          .cs_writedata_i           (cs_writedata_i           ),
          .cs_writeresponsevalid_o  (cs_writeresponsevalid_o  ),
          .cs_response_o            (cs_response_o            ),
        
          .wrdm_readdatavalid_i     (wrdm_readdatavalid_i     ),
          .wrdm_readdata_i          (wrdm_readdata_i          ),
          .wrdm_response_i          (wrdm_response_i          ),
          .wrdm_waitrequest_i       (wrdm_waitrequest_i       ),
          .wrdm_vfactive_o          (wrdm_vfactive_o          ),
          .wrdm_pfnum_o             (wrdm_pfnum_o             ),
          .wrdm_vfnum_o             (wrdm_vfnum_o             ),
          .wrdm_read_o              (wrdm_read_o              ),
          .wrdm_address_o           (wrdm_address_o           ),
          .wrdm_burstcount_o        (wrdm_burstcount_o        ),
          .wrdm_byteenable_o        (wrdm_byteenable_o        ),
        
          .rddm_writedata_o         (rddm_writedata_o         ),
          .rddm_byteenable_o        (rddm_byteenable_o        ),
          .rddm_burstcount_o        (rddm_burstcount_o        ),
          .rddm_address_o           (rddm_address_o           ),
          .rddm_write_o             (rddm_write_o             ),
          .rddm_waitrequest_i       (rddm_waitrequest_i       ),
          .rddm_vfactive_o          (rddm_vfactive_o          ),
          .rddm_pfnum_o             (rddm_pfnum_o             ),
          .rddm_vfnum_o             (rddm_vfnum_o             ),
        
          .bam_readdatavalid_i      (bam_readdatavalid_i      ),
          .bam_readdata_i           (bam_readdata_i           ),
          .bam_response_i           (bam_response_i           ),
          .bam_waitrequest_i        (bam_waitrequest_i        ),
          .bam_writeresponsevalid_i (1'b0 ),
          .bam_vfactive_o           (bam_vfactive_o           ),
          .bam_pfnum_o              (bam_pfnum_o              ),
          .bam_vfnum_o              (bam_vfnum_o              ),
          .bam_read_o               (bam_read_o               ),
          .bam_write_o              (bam_write_o              ),
          .bam_address_o            (bam_address_wire         ),
          .bam_burstcount_o         (bam_burstcount_o         ),
          .bam_byteenable_o         (bam_byteenable_o         ),
          .bam_bar_o                (bam_bar_o                ),
          .bam_writedata_o          (bam_writedata_o          ),
        
          .bas_vfactive_i           (bas_vfactive_i           ),
          .bas_pfnum_i              (bas_pfnum_i              ),
          .bas_vfnum_i              (bas_vfnum_i              ),
          .bas_address_i            (bas_address_i            ),
          .bas_byteenable_i         (bas_byteenable_i         ),
          .bas_read_i               (bas_read_i               ),
          .bas_write_i              (bas_write_i              ),
          .bas_writedata_i          (bas_writedata_i          ),
          .bas_burstcount_i         (bas_burstcount_i         ),
          .bas_waitrequest_o        (bas_waitrequest_o        ),
          .bas_readdata_o           (bas_readdata_o           ),
          .bas_readdatavalid_o      (bas_readdatavalid_o      ),
          .bas_response_o           (bas_response_o           ),
        
          // DMA Controller Interface
          // Write data mover interface
          .wrdm_desc_valid_i             (wrdm_desc_valid_i),
          .wrdm_desc_data_i              (wrdm_desc_data_i ),
          .wrdm_desc_ready_o             (wrdm_desc_ready_o),
        
          .wrdm_prio_valid_i             (wrdm_prio_valid_i),
          .wrdm_prio_data_i              (wrdm_prio_data_i ),
          .wrdm_prio_ready_o             (wrdm_prio_ready_o),
        
          .wrdm_tx_data_o                (wrdm_tx_data_o   ),
          .wrdm_tx_valid_o               (wrdm_tx_valid_o  ),
        
          .rddm_desc_valid_i             (rddm_desc_valid_i),
          .rddm_desc_data_i              (rddm_desc_data_i ),
          .rddm_desc_ready_o             (rddm_desc_ready_o),
        
          .rddm_prio_valid_i             (rddm_prio_valid_i),
          .rddm_prio_data_i              (rddm_prio_data_i ),
          .rddm_prio_ready_o             (rddm_prio_ready_o),
        
          .rddm_tx_data_o                (rddm_tx_data_o   ),
          .rddm_tx_valid_o               (rddm_tx_valid_o  )
        
        );
	  end

	  else begin 
      intel_pcie_avmm_bridge_512_dcore
      #(
      // The value type (integer/string) will change based on hw_tcl development.
        .enable_write_mover            (enable_write_mover_hwtcl            ),
        .enable_read_mover             (enable_read_mover_hwtcl             ),
        .enable_legacy_interrupt       (enable_legacy_interrupt_hwtcl       ),
        .enable_bursting_slave         (enable_bursting_slave_hwtcl         ),
        .enable_bursting_master        (enable_bursting_master_hwtcl        ),
        .enable_sriov                  (enable_sriov_hwtcl                  ),
        .enable_root_port              (enable_root_port_hwtcl              ),
        .bursting_slave_address_width  (bursting_slave_address_width_hwtcl  ),
        .read_mover_address_width      (read_mover_address_width_hwtcl      ),
        .write_mover_address_width     (write_mover_address_width_hwtcl     ),
        .enable_config_slave           (enable_config_slave_hwtcl           ),
        .config_slave_address_width    (config_slave_address_width_hwtcl    ),
        .virtual_maxpayload_size_hwtcl (virtual_maxpayload_size_hwtcl       ),
        .en_order_rx_posted_cpl_hwtcl  (en_order_rx_posted_cpl_hwtcl        ),
        .DEVICE_FAMILY                 (device_family                       ),
        .PFNUM                         (total_pf_count_hwtcl                ),
        .PFNUM_WIDTH                   (total_pf_count_width_hwtcl          ),
        .VFNUM_WIDTH                   (total_vf_count_width_hwtcl          ),
        .SIMULATION_SPEEDUP            (SIMULATION_SPEEDUP                  ),
        .pf0_bar0_address_width_hwtcl  (pf0_bar0_address_width_hwtcl        ),
        .pf0_bar1_address_width_hwtcl  (pf0_bar1_address_width_hwtcl        ),
        .pf0_bar2_address_width_hwtcl  (pf0_bar2_address_width_hwtcl        ),
        .pf0_bar3_address_width_hwtcl  (pf0_bar3_address_width_hwtcl        ),
        .pf0_bar4_address_width_hwtcl  (pf0_bar4_address_width_hwtcl        ),
        .pf0_bar5_address_width_hwtcl  (pf0_bar5_address_width_hwtcl        )
      )
      avmm_512_inst  (
        // clock and reset
        .clk                       (clk_wire),
        .rst_n                     (rst_n_wire),

        // Interface to the Streaming ports of HIP.
        //RX Ports
        .rx_st_ready_o                         (rx_st_ready_wire),
        .rx_st_valid_i                         (rx_st_valid_wire),
        .rx_st_sop_i                           (rx_st_sop_wire),
        .rx_st_eop_i                           (rx_st_eop_wire),
        .rx_st_hdr_i                           (rx_st_hdr_switch_wire),
        .rx_st_data_i                          (rx_st_data_wire),
        .rx_st_vf_active_i                     (rx_st_vf_active_wire),
        .rx_st_func_num_i                      (rx_st_func_num_wire),
        .rx_st_vf_num_i                        (rx_st_vf_num_wire),
        .rx_st_bar_range_i                     (rx_st_bar_range_wire),
        .rx_par_err_i                          (rx_par_err_wire),

        //TX Ports
        .tx_st_ready_i                         (tx_st_ready_wire),
        .tx_par_err_i                          (tx_par_err_wire),
        .tx_st_valid_o                         (tx_st_valid_wire),
        .tx_st_sop_o                           (tx_st_sop_wire),
        .tx_st_eop_o                           (tx_st_eop_wire),
        .tx_st_err_o                           (tx_st_err_wire),
        .tx_st_hdr_o                           (tx_st_hdr_switch_wire),
        .tx_st_data_o                          (tx_st_data_wire),
        .tx_st_vf_active_o                     (tx_st_vf_active_wire),

        // Streaming Packets HIP Credit Interface.
        .tx_cdts_limit_i                       (tx_cdts_limit_wire           ),
        .tx_cdts_limit_tdm_idx_i               (tx_cdts_limit_tdm_idx_wire   ),
        .rx_buffer_limit_o                     (rx_buffer_limit_wire         ),
        .rx_buffer_limit_tdm_idx_o             (rx_buffer_limit_tdm_idx_wire ),


        // HIP Misc interface
        // Config Interface
        .tl_cfg_func                           (tl_cfg_func_wire),
        .tl_cfg_add                            (tl_cfg_add_wire ),
        .tl_cfg_ctl                            (tl_cfg_ctl_wire ),


        // Information extracted from tl_cfg
        // Add these to adapter later
        .mps_i                                 (mps_logic                            ),
        .mrrs_i                                (mrrs_logic                           ),
        .bus_master_enabled_i                  (bus_master_enable_o[PFNUM-1:0]  ),

        /*   // Information extracted from config space.
        input logic                                     pf0_completion_timeout_valid_i, // Asserted when fresh data is present. // Not used.
        input logic [3:0]                               pf0_completion_timeout_period_i,
        input logic                                     pf0_completion_timeout_disable_i,

         */
        .cs_waitrequest_o         (cs_waitrequest_o         ),
        .cs_address_i             (cs_address_i             ),
        .cs_byteenable_i          (cs_byteenable_i          ),
        .cs_read_i                (cs_read_i                ),
        .cs_readdata_o            (cs_readdata_o            ),
        .cs_readdatavalid_o       (cs_readdatavalid_o       ),
        .cs_write_i               (cs_write_i               ),
        .cs_writedata_i           (cs_writedata_i           ),
        .cs_writeresponsevalid_o  (cs_writeresponsevalid_o  ),
        .cs_response_o            (cs_response_o            ),

        .wrdm_readdatavalid_i     (wrdm_readdatavalid_i     ),
        .wrdm_readdata_i          (wrdm_readdata_i          ),
        .wrdm_response_i          (wrdm_response_i          ),
        .wrdm_waitrequest_i       (wrdm_waitrequest_i       ),
        .wrdm_vfactive_o          (wrdm_vfactive_o          ),
        .wrdm_pfnum_o             (wrdm_pfnum_o             ),
        .wrdm_vfnum_o             (wrdm_vfnum_o             ),
        .wrdm_read_o              (wrdm_read_o              ),
        .wrdm_address_o           (wrdm_address_o           ),
        .wrdm_burstcount_o        (wrdm_burstcount_o        ),
        .wrdm_byteenable_o        (wrdm_byteenable_o        ),

        .rddm_writedata_o         (rddm_writedata_o         ),
        .rddm_byteenable_o        (rddm_byteenable_o        ),
        .rddm_burstcount_o        (rddm_burstcount_o        ),
        .rddm_address_o           (rddm_address_o           ),
        .rddm_write_o             (rddm_write_o             ),
        .rddm_waitrequest_i       (rddm_waitrequest_i       ),
        .rddm_vfactive_o          (rddm_vfactive_o          ),
        .rddm_pfnum_o             (rddm_pfnum_o             ),
        .rddm_vfnum_o             (rddm_vfnum_o             ),

        .bam_readdatavalid_i      (bam_readdatavalid_i      ),
        .bam_readdata_i           (bam_readdata_i           ),
        .bam_response_i           (bam_response_i           ),
        .bam_waitrequest_i        (bam_waitrequest_i        ),
        .bam_writeresponsevalid_i (bam_writeresponsevalid_i ),
        .bam_vfactive_o           (bam_vfactive_o           ),
        .bam_pfnum_o              (bam_pfnum_o              ),
        .bam_vfnum_o              (bam_vfnum_o              ),
        .bam_read_o               (bam_read_o               ),
        .bam_write_o              (bam_write_o              ),
        .bam_address_o            (bam_address_o            ),
        .bam_burstcount_o         (bam_burstcount_o         ),
        .bam_byteenable_o         (bam_byteenable_o         ),
        .bam_bar_o                (bam_bar_o                ),
        .bam_writedata_o          (bam_writedata_o          ),

        .bas_vfactive_i           (bas_vfactive_i           ),
        .bas_pfnum_i              (bas_pfnum_i              ),
        .bas_vfnum_i              (bas_vfnum_i              ),
        .bas_address_i            (bas_address_i            ),
        .bas_byteenable_i         (bas_byteenable_i         ),
        .bas_read_i               (bas_read_i               ),
        .bas_write_i              (bas_write_i              ),
        .bas_writedata_i          (bas_writedata_i          ),
        .bas_burstcount_i         (bas_burstcount_i         ),
        .bas_waitrequest_o        (bas_waitrequest_o        ),
        .bas_readdata_o           (bas_readdata_o           ),
        .bas_readdatavalid_o      (bas_readdatavalid_o      ),
        .bas_response_o           (bas_response_o           ),

        // DMA Controller Interface
        // Write data mover interface
        .wrdm_desc_valid_i             (wrdm_desc_valid_i),
        .wrdm_desc_data_i              (wrdm_desc_data_i ),
        .wrdm_desc_ready_o             (wrdm_desc_ready_o),

        .wrdm_prio_valid_i             (wrdm_prio_valid_i),
        .wrdm_prio_data_i              (wrdm_prio_data_i ),
        .wrdm_prio_ready_o             (wrdm_prio_ready_o),

        .wrdm_tx_data_o                (wrdm_tx_data_o   ),
        .wrdm_tx_valid_o               (wrdm_tx_valid_o  ),

        .rddm_desc_valid_i             (rddm_desc_valid_i),
        .rddm_desc_data_i              (rddm_desc_data_i ),
        .rddm_desc_ready_o             (rddm_desc_ready_o),

        .rddm_prio_valid_i             (rddm_prio_valid_i),
        .rddm_prio_data_i              (rddm_prio_data_i ),
        .rddm_prio_ready_o             (rddm_prio_ready_o),

        .rddm_tx_data_o                (rddm_tx_data_o   ),
        .rddm_tx_valid_o               (rddm_tx_valid_o  )

      );
    end
	end 
    if (payload_width_integer_hwtcl == 256 ) begin

      intel_pio_clkCtrl pio_clkCtrl (
        .inclk (clk),
        .clock_div1x (),
        .clock_div2x (clk_250)
      );

      assign rst_n_clk250 = rst_n_clk250_sync;

      altera_std_synchronizer_nocut reset_sync (
        .clk     (clk_250),
        .reset_n (rst_n),
        .din     (rst_n),
        .dout    (rst_n_clk250_sync)
      );

      intel_pcie_whr_gen4x8_avmm_adapter
      #(
        .pld_tx_parity_ena   (0),
        .pld_rx_parity_ena   (0),
        .enable_sriov_hwtcl  (0), 
        .intended_device_family(device_family)
      )
      adapter_256_to_512_avmm_gen4x8 (
        .clk250                       (clk_250),
        .clk500                       (clk),
        .rx_st_bar_range_i            (rx_st_bar_range_i ),
        .rx_st_data_i                 (rx_st_data_i      ),
        .rx_st_empty_i                (rx_st_empty_i     ),
        .rx_st_eop_i                  (rx_st_eop_i       ),
        .rx_st_func_num_i             (rx_st_func_num_i[PFNUM_WIDTH-1:0]  ),
        .rx_st_hdr_i                  (rx_st_hdr_i       ),
        .rx_st_data_par_i             ('b0),
        .rx_st_hdr_par_i              ('b0),
        .rx_st_ready_i                (rx_st_ready_wire  ),
        .rx_st_sop_i                  (rx_st_sop_i       ),
        .rx_st_valid_i                (rx_st_valid_i     ),
        .rx_st_vf_active_i            (rx_st_vf_active_i ),
        .rx_st_vf_num_i               (rx_st_vf_num_i[VFNUM_WIDTH-1:0]    ),
        .tx_st_data_i                 (tx_st_data_wire   ),
        .tx_st_eop_i                  (tx_st_eop_wire    ),
        .tx_st_err_i                  (tx_st_err_wire    ),
        .tx_st_hdr_i                  (tx_st_hdr_wire    ),
        .tx_st_data_par_i             ('b0),
        .tx_st_hdr_par_i              ('b0),
        .tx_st_ready_i                (tx_st_ready_i        ),
        .tx_st_sop_i                  (tx_st_sop_wire       ),
        .tx_st_valid_i                (tx_st_valid_wire     ),

        .rx_st_bar_range_o            (rx_st_bar_range_wire ),
        .rx_st_data_o                 (rx_st_data_wire      ),
        .rx_st_empty_o                (rx_st_empty_wire     ),
        .rx_st_eop_o                  (rx_st_eop_wire       ),
        .rx_st_func_num_o             (rx_st_func_num_wire  ),
        .rx_st_hdr_o                  (rx_st_hdr_wire       ),
        .rx_st_data_par_o             (),
        .rx_st_hdr_par_o              (),
        .rx_st_ready_o                (rx_st_ready_o        ),
        .rx_st_sop_o                  (rx_st_sop_wire       ),
        .rx_st_valid_o                (rx_st_valid_wire     ),
        .rx_st_vf_active_o            (rx_st_vf_active_wire ),
        .rx_st_vf_num_o               (rx_st_vf_num_wire    ),

        .tx_st_data_o                 (tx_st_data_o         ),
        .tx_st_eop_o                  (tx_st_eop_o          ),
        .tx_st_err_o                  (tx_st_err_o          ),
        .tx_st_hdr_o                  (tx_st_hdr_o          ),
        .tx_st_data_par_o             (),
        .tx_st_hdr_par_o              (),
        .tx_st_ready_o                (tx_st_ready_wire     ),
        .tx_st_sop_o                  (tx_st_sop_o          ),
        .tx_st_valid_o                (tx_st_valid_o        ),

        .tl_cfg_add_i                 (tl_cfg_add_i ),
        .tl_cfg_ctl_i                 (tl_cfg_ctl_i ),
        .tl_cfg_func_i                (tl_cfg_func_i),
        .tl_cfg_add_o                 (tl_cfg_add_wire ),
        .tl_cfg_ctl_o                 (tl_cfg_ctl_wire ),
        .tl_cfg_func_o                (tl_cfg_func_wire),

        .rst_n                        (rst_n),
        .rst_n_clk250                 (rst_n_clk250),


        //g4x8 adapter credit interface
        .tx_cdts_limit_i              (tx_cdts_limit_i         ),
        .tx_cdts_limit_tdm_idx_i      (tx_cdts_limit_tdm_idx_i ),
        .tx_cdts_limit_o              (tx_cdts_limit_wire),
        .tx_cdts_limit_tdm_idx_o      (tx_cdts_limit_tdm_idx_wire),
        .rx_buffer_limit_o            (rx_buffer_limit_o        ),
        .rx_buffer_limit_tdm_idx_o    (rx_buffer_limit_tdm_idx_o),
        .rx_buffer_limit_i            (rx_buffer_limit_wire),
        .rx_buffer_limit_tdm_idx_i    (rx_buffer_limit_tdm_idx_wire),

      // Error Interface

        .serr_out_i                   ('b0),
        .hip_enter_err_mode_i         ('b0),
        .app_err_valid_i              ('b0),
        .app_err_hdr_i                ('b0),
        //.app_err_tlp_prfx_i         ('b0),
        .app_err_func_num_i           ('b0),

        .serr_out_o                   (),
        .hip_enter_err_mode_o         (),
        .app_err_valid_o              (),
        .app_err_hdr_o                (),
        .app_err_func_num_o           (),

        .rx_par_err_i                 ('b0),
        .tx_par_err_i                 ('b0),
        .rx_par_err_o                 (),
        .tx_par_err_o                 (),

      // FLR Interface

        .flr_rcvd_pf_i                ('b0),
        .flr_rcvd_vf_i                ('b0),
        .flr_rcvd_pf_num_i            ('b0),
        .flr_rcvd_vf_num_i            ('b0),
        .flr_completed_pf_o           (),
        .flr_completed_vf_o           (),
        .flr_completed_pf_num_o       (),
        .flr_completed_vf_num_o       (),


        .cii_req_i                    ('b0),
        .cii_hdr_poisoned_i           ('b0),
        .cii_hdr_first_be_i           ('b0),
        .cii_func_num_i               ('b0),
        .cii_wr_vf_active_i           ('b0),
        .cii_vf_num_i                 ('b0),
        .cii_wr_i                     ('b0),
        .cii_dout_i                   ('b0),
        .cii_override_en_o            (),
        .cii_override_din_o           (),
        .cii_halt_o                   (),

        .cii_req_o                    (),
        .cii_hdr_poisoned_o           (),
        .cii_hdr_first_be_o           (),
        .cii_func_num_o               (),
        .cii_wr_vf_active_o           (),
        .cii_vf_num_o                 (),
        .cii_wr_o                     (),
        .cii_dout_o                   (),
        .cii_override_en_i            ('b0),
        .cii_override_din_i           ('b0),
        .cii_halt_i                   ('b0),

        .int_status_i                 ('b0),

        .msi_pnd_func_o               (),
        .msi_pnd_byte_o               (),

        .int_status_o                 (),

        //ports that already defined in dcore
        .tx_st_tlp_prfx_o             (),
        .tx_st_tlp_prfx_par_o         (tx_st_tlp_prfx_par_o),
        .rx_st_tlp_prfx_i             (rx_st_tlp_prfx_i),
        .rx_st_tlp_prfx_par_i         (rx_st_tlp_prfx_par_i),


      //ports not declared in dcore yet  
     
        .tx_st_tlp_prfx_i              ('b0),                                                                                                                                                              
        .tx_st_tlp_prfx_par_i          ('b0),                                                                                                                                                              
        .rx_st_tlp_prfx_o              (),                                                                                                                                                               
        .rx_st_tlp_prfx_par_o          (),                                                                                                                                                               
        .cii_addr_i                    ('b0),          
        .cii_addr_o                    (),          
        .link_up_i                     ('b0),        
        .dl_up_i                       ('b0),      
        .ltssm_state_i                 ('b0),            
        .link_up_o                     (),        
        .dl_up_o                       (),      
        .ltssm_state_o                 (),            
        .prs_event_valid_i             ('b0),                
        .prs_event_func_i              ('b0),                
        .prs_event_i                   ('b0),          
        .prs_event_valid_o             (),                
        .prs_event_func_o              (),                
        .prs_event_o                   (),          
        .pm_state_i                    ('b0),          
        .apps_pm_xmt_pme_i             ('b0),                
        .app_ready_entr_l23_i          ('b0),                    
        .apps_pm_xmt_turnoff_i         ('b0),                    
        .app_xfer_pending_i            ('b0),                  
        .pm_state_o                    (),          
        .apps_pm_xmt_pme_o             (),                
        .app_ready_entr_l23_o          (),                    
        .apps_pm_xmt_turnoff_o         (),                                                                      
        .app_xfer_pending_o            (),                  
        .sys_atten_button_pressed_i    ('b0),                          
        .sys_pwr_fault_det_i           ('b0),                                            
        .sys_mrl_sensor_chged_i        ('b0),                      
        .sys_pre_det_chged_i           ('b0),                  
        .sys_pre_det_state_i           ('b0),                  
        .sys_mrl_sensor_state_i        ('b0),                      
        .sys_aux_pwr_det_i             ('b0),                
        .sys_atten_button_pressed_o    (),                          
        .sys_pwr_fault_det_o           (),                  
        .sys_mrl_sensor_chged_o        (),                      
        .sys_pre_det_chged_o           (),                  
        .sys_pre_det_state_o           (),                  
        .sys_mrl_sensor_state_o        (),                      
        .sys_aux_pwr_det_o             (),                
        .msi_pnd_addr_i                ('b0),              
        .msi_pnd_addr_o                ()              
      );

    end
  endgenerate

endmodule

