// (C) 2001-2021 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



// synopsys translate_off
`timescale 1 ps / 1 ps
// synopsys translate_on

module intel_pcie_lite_master
  #(
    parameter PFNUM_WIDTH = 2,
    parameter VFNUM_WIDTH = 12,
    parameter pf0_bar0_address_width_hwtcl = 1,
    parameter pf0_bar1_address_width_hwtcl = 1,
    parameter pf0_bar2_address_width_hwtcl = 1,
    parameter pf0_bar3_address_width_hwtcl = 1,
    parameter pf0_bar4_address_width_hwtcl = 1,
    parameter pf0_bar5_address_width_hwtcl = 1

    )
  (
   input logic           clk,
   input logic           rst_n,

   
    input  logic             bam_rx_valid_i, 
    input  logic  [127:0]    bam_rx_hdr_i,
    input  logic  [511:0]    bam_rx_payload_i,   
                             
    input  logic             bam_rx_vf_active_i,    
    input  logic [1:0]       bam_rx_func_num_i ,    
    input  logic [11:0]      bam_rx_vf_num_i   ,    
    input  logic [2:0]       bam_rx_bar_i      ,  
//    output logic             bam_write_resp_i,
    output logic             bam_writeresponsevalid_o,
    output logic             bam_rx_rdy_o,
                             
    output logic             litem_cpl_req_o,
    output logic [95:0]      litem_cpl_hdr_o,
    output logic             litem_cpl_vfactive_o,
    output logic [511:0]     litem_cpl_data_o,
    input  logic             litem_cpl_ack_i,
                             
    output logic             lite_master_write_o,
    output logic  [63:0]     lite_master_address_o,
    output logic  [3:0]      lite_master_burst_count_o,
    output logic  [63:0]     lite_master_byte_enable_o,
    output logic  [511:0]    lite_master_write_data_o,
    input  logic             lite_master_wait_request_i,
    output logic             lite_master_read_o,
    input  logic  [511:0]    lite_master_readdata_i,
    input  logic             lite_master_readdata_valid_i,
    output [PFNUM_WIDTH-1:0] lite_master_pfnum_o,
    output [VFNUM_WIDTH-1:0] lite_master_vfnum_o,
    output                   lite_master_vfactive_o,
    output [2:0]             lite_master_bar_o
    
  );

  logic [31:0] data_reg1_dw0;
  logic [31:0] data_reg1_dw1;
  logic [31:0] data_reg1_dw2;
  logic [31:0] data_reg1_dw3;
  logic [31:0] data_reg1_dw4;
  logic [31:0] data_reg1_dw5;
  logic [31:0] data_reg1_dw6;
  logic [31:0] data_reg1_dw7;
  logic [31:0] data_reg1_dw8;
  logic [31:0] data_reg1_dw9;
  logic [31:0] data_reg1_dw10;
  logic [31:0] data_reg1_dw11;
  logic [31:0] data_reg1_dw12;
  logic [31:0] data_reg1_dw13;
  logic [31:0] data_reg1_dw14;
  logic [31:0] data_reg1_dw15;
  logic [31:0] hold_reg_dw0; 
  logic [31:0] hold_reg_dw1; 
  logic [31:0] hold_reg_dw2; 
  logic [31:0] hold_reg_dw3; 
  logic [31:0] hold_reg_dw4; 
  logic [31:0] hold_reg_dw5; 
  logic [31:0] hold_reg_dw6; 
  logic [31:0] hold_reg_dw7; 
  logic [31:0] hold_reg_dw8; 
  logic [31:0] hold_reg_dw9; 
  logic [31:0] hold_reg_dw10;
  logic [31:0] hold_reg_dw11;
  logic [31:0] hold_reg_dw12;
  logic [31:0] hold_reg_dw13;
  logic [31:0] hold_reg_dw14;
  logic [31:0] hold_reg_dw15;
  logic [31:0] data_mux_out0; 
  logic [31:0] data_mux_out1;  
  logic [31:0] data_mux_out2;  
  logic [31:0] data_mux_out3;  
  logic [31:0] data_mux_out4;  
  logic [31:0] data_mux_out5;  
  logic [31:0] data_mux_out6;  
  logic [31:0] data_mux_out7;  
  logic [31:0] data_mux_out8;  
  logic [31:0] data_mux_out9;  
  logic [31:0] data_mux_out10; 
  logic [31:0] data_mux_out11; 
  logic [31:0] data_mux_out12; 
  logic [31:0] data_mux_out13; 
  logic [31:0] data_mux_out14; 
  logic [31:0] data_mux_out15; 
  logic [31:0] data_mux_dw0_reg1; 	
  logic [31:0] data_mux_dw1_reg1; 	
  logic [31:0] data_mux_dw2_reg1; 	
  logic [31:0] data_mux_dw3_reg1; 	
  logic [31:0] data_mux_dw4_reg1; 	
  logic [31:0] data_mux_dw5_reg1; 	
  logic [31:0] data_mux_dw6_reg1; 	
  logic [31:0] data_mux_dw7_reg1; 	
  logic [31:0] data_mux_dw8_reg1; 	
  logic [31:0] data_mux_dw9_reg1; 	
  logic [31:0] data_mux_dw10_reg1;	
  logic [31:0] data_mux_dw11_reg1;	
  logic [31:0] data_mux_dw12_reg1;	
  logic [31:0] data_mux_dw13_reg1;	
  logic [31:0] data_mux_dw14_reg1;	
  logic [31:0] data_mux_dw15_reg1;	
  logic [31:0] data_mux_dw0_reg2; 	
  logic [31:0] data_mux_dw1_reg2; 	
  logic [31:0] data_mux_dw2_reg2; 	
  logic [31:0] data_mux_dw3_reg2; 	
  logic [31:0] data_mux_dw4_reg2; 	
  logic [31:0] data_mux_dw5_reg2; 	
  logic [31:0] data_mux_dw6_reg2; 	
  logic [31:0] data_mux_dw7_reg2; 	
  logic [31:0] data_mux_dw8_reg2; 	
  logic [31:0] data_mux_dw9_reg2; 	
  logic [31:0] data_mux_dw10_reg2;	
  logic [31:0] data_mux_dw11_reg2;	
  logic [31:0] data_mux_dw12_reg2;	
  logic [31:0] data_mux_dw13_reg2;	
  logic [31:0] data_mux_dw14_reg2;	
  logic [31:0] data_mux_dw15_reg2;	
  (*maxfan = 32*) logic        srst_reg;
  logic [9:0]  tlp_len_reg1;   
  logic        tlp_hdr_4dw_reg1; 
  logic [63:0] tlp_addr_reg1;   
  logic [2:0]  tlp_bar_reg1;    
  logic        tlp_vfactive_reg1;
  logic [1:0]  tlp_pfnum_reg1;   
  logic [11:0] tlp_vfnum_reg1;  
  logic [7:0]  tlp_tag_reg1;    
  logic [2:0]  tlp_attr_reg1;   
  logic [2:0]  tlp_tc_reg1;      
  logic [15:0] tlp_reqid_reg1;   
  logic [3:0]  tlp_fbe_reg1;    
  logic [3:0]  tlp_lbe_reg1;    
  logic        tlp_is_wr_reg1;   
  logic        tlp_is_rd_reg1;   
  logic        tlp_lbe_zero_reg1; 
  logic [9:0]  tlp_dw_size_reg2;
  logic   [63:0] pf0_addr_mask_reg2;
  logic   [63:0] pf0_addr_mask_reg3;
  logic   [63:0]     pf0_bar0_address_mask     =  { {(64-pf0_bar0_address_width_hwtcl){1'b0}},   {(pf0_bar0_address_width_hwtcl){1'b1}} };
  logic   [63:0]     pf0_bar1_address_mask     =  { {(64-pf0_bar1_address_width_hwtcl){1'b0}},   {(pf0_bar1_address_width_hwtcl){1'b1}} };
  logic   [63:0]     pf0_bar2_address_mask     =  { {(64-pf0_bar2_address_width_hwtcl){1'b0}},   {(pf0_bar2_address_width_hwtcl){1'b1}} };
  logic   [63:0]     pf0_bar3_address_mask     =  { {(64-pf0_bar3_address_width_hwtcl){1'b0}},   {(pf0_bar3_address_width_hwtcl){1'b1}} };
  logic   [63:0]     pf0_bar4_address_mask     =  { {(64-pf0_bar4_address_width_hwtcl){1'b0}},   {(pf0_bar4_address_width_hwtcl){1'b1}} };
  logic   [63:0]     pf0_bar5_address_mask     =  { {(64-pf0_bar5_address_width_hwtcl){1'b0}},   {(pf0_bar5_address_width_hwtcl){1'b1}} };
  //logic [6:0]  litem_nxt_state;
  //(* syn_encoding="one-hot"*) logic [6:0]  litem_state;
  typedef enum logic [6:0]  {

     LITEM_IDLE       = 7'b0000001,
     LITEM_FF_RD      = 7'b0000010,
     LITEM_WAIT_CMD   = 7'b0000100,
     LITEM_RD         = 7'b0001000,
     LITEM_WAIT_RDAT  = 7'b0010000,
     LITEM_CPL        = 7'b0100000,
     LITEM_WR         = 7'b1000000
  } litem_state_t;
  (* syn_encoding="one-hot"*) litem_state_t litem_state;
  litem_state_t litem_nxt_state;

  logic        litem_wr_state;        
  logic        litem_rd_state;      
  logic        litem_cpl_state;        
  logic [63:0] avmm_fbe_reg2; 
  logic [63:0] avmm_fbe_reg3; 
  logic [63:0] avmm_fbe_reg4; 
  logic [3:0]  tlp_lbe_reg2;     
  logic [5:0]  avmm_address_plus_dw_size_reg2;
  logic [63:0] avmm_lbe_reg3;    
  logic [63:0] avmm_be_reg4;
  logic [63:0] avmm_address_reg4;        
  logic [511:0] write_data_reg3;
  logic [511:0] write_data_reg4;
  logic        wrcmd_avail_reg2; 
  logic        wrcmd_avail_reg3; 
  logic        rdcmd_avail_reg2;
  logic        rdcmd_avail_reg3;  
  logic [63:0] lite_master_wr_byte_enable;
  logic [63:0] lite_master_rd_byte_enable;
  logic [11:0] avmm_vfnum_reg4; 
  logic [1:0]  avmm_pfnum_reg4;    
  logic        avmm_vfactive_reg4;     
  logic [2:0]  avmm_bar_reg4;   
  logic [511:0] litem_cpl_data_reg; 
  logic [8:0]   shiftright_index;
  logic [511:0] cpl_data_mux;
  logic [511:0] tlp_cpl_data_reg;   
  logic [511:0] tlp_cpl_data_reg2;  
  logic [11:0]  remain_bytes;	                             
  logic [1:0]   last_invalid_bytes_reg2; 
  logic [1:0]   last_invalid_bytes_reg3;
  logic [1:0]   first_invalid_bytes_reg2;
  logic [11:0]  total_rd_bytes_reg3;
  logic [11:0]  total_rd_bytes_reg4;
  logic [15:0]  cpl_vfpf;  
  logic [15:0]  cpl_reqster_id;
  logic [9:0]   cpl_len;
  logic [5:0]   cpl_td_attr;
  logic [7:0]   cpl_tc;
  logic [7:0]   cpl_cmd;   
  logic [11:0]  cpl_byte_count;
  logic [3:0]   cpl_stat_bcm;  
  logic [1:0]   lower_addr_offset_reg2;
  logic [6:0]   cpl_lower_addr_reg2;
  logic [6:0]   cpl_lower_addr_reg3;
  logic [67:0]  cpl_lower_addr; 
  logic [7:0]   cpl_tag;
  //// Completion
  logic [6:0]    cpl_lower_addr_i;
  logic [6:0]    cpl_lower_addr_wire;
  
  logic [9:0]    cpl_len_wire;
  logic [5:0]    cpl_attr_wire;
  logic [2:0]    cpl_tc_wire;
  logic [3:0]    cpl_fbe_wire;
  logic [3:0]    cpl_lbe_wire;
  logic [7:0]    cpl_tag_wire;
  logic [15:0]   cpl_reqid_wire;
  
  logic [1:0]    cpl_pfnum_wire;
  logic [11:0]   cpl_vfnum_wire;
  logic [6:0]    cpl_addr_wire;
  logic          cpl_lbe_zero_wire;
  logic          cpl_vfactive_wire;
  logic [2:0]    rx_fmt;
  logic [4:0]    rx_type;
  logic          mem_rd_tlp;
  logic          flush_rd_reg1;
  logic          flush_rd_reg2;
  logic          flush_rd_reg3;
  logic          flush_rd_reg4;
  logic          cpl_for_flush_rd;
  logic [145:0]  litem_i_hdr_q;
  logic [512:0]  litem_i_payld_q;
  logic  litem_i_ff_empty;
  logic  litem_i_ff_rd;
  logic  litem_i_ff_afull;
  
  logic litem_rdat_valid_r1;
  logic litem_rdat_valid_r2;
  logic litem_rdat_valid_r3;
  logic litem_o_fifo_wreq;
  logic [145:0] litem_rx_hdr_i;
  logic [127:0] litem_cpl_hdr_wire;
  logic [127:0] litem_o_hdr_q;
  logic [512:0] litem_cpl_data_wire;
  logic [512:0] litem_o_payld_q;
  logic litem_hdr_o_ff_afull;
  logic litem_hdr_o_ff_empty;
  logic litem_o_fifo_rreq;
  logic [2:0] tlp_bar_reg2;
  logic [63:0] tlp_addr_reg2;
  logic [63:0] tlp_addr_reg3;

assign bam_rx_rdy_o = ~litem_i_ff_afull;
assign litem_rx_hdr_i = {bam_rx_bar_i, bam_rx_vf_active_i,bam_rx_vf_num_i[11:0],bam_rx_func_num_i[1:0],bam_rx_hdr_i};

scfifo  litem_hdr_i_fifo (
      .clock                            (clk),
      .data                             (litem_rx_hdr_i),
      .rdreq                            (litem_i_ff_rd), 
      .wrreq                            (bam_rx_valid_i),
      .almost_full                      (litem_i_ff_afull),
      .full                             (),
      .q                                (litem_i_hdr_q),
      .aclr                             (1'b0),
      .almost_empty                     (),   
      .eccstatus                        (),
      .empty                            (litem_i_ff_empty),
      .sclr                             (srst_reg),
      .usedw                            ());
  defparam
      litem_hdr_i_fifo.add_ram_output_register  = "ON",
      litem_hdr_i_fifo.almost_full_value  = 7,
      litem_hdr_i_fifo.almost_empty_value  = 2,
      litem_hdr_i_fifo.enable_ecc  = "FALSE",
      litem_hdr_i_fifo.intended_device_family  = "Stratix 10",
      litem_hdr_i_fifo.lpm_hint  = "RAM_BLOCK_TYPE=MLAB",
      litem_hdr_i_fifo.lpm_numwords  = 8,
      litem_hdr_i_fifo.lpm_showahead  = "ON",
      litem_hdr_i_fifo.lpm_type  = "scfifo",
      litem_hdr_i_fifo.lpm_width  = (146),
      litem_hdr_i_fifo.lpm_widthu  = 3,
      litem_hdr_i_fifo.overflow_checking  = "OFF",
      litem_hdr_i_fifo.underflow_checking  = "OFF", 
      litem_hdr_i_fifo.use_eab  = "ON";

scfifo  bam_dat_i_fifo (
      .clock                            (clk),
      .data                             (bam_rx_payload_i),
      .rdreq                            (litem_i_ff_rd), 
      .wrreq                            (bam_rx_valid_i),
      .almost_full                      (),
      .full                             (),
      .q                                (litem_i_payld_q),
      .aclr                             (1'b0),
      .almost_empty                     (),   
      .eccstatus                        (),
      .empty                            (),
      .sclr                             (srst_reg),
      .usedw                            ());
  defparam
      bam_dat_i_fifo.add_ram_output_register  = "ON",
      bam_dat_i_fifo.almost_full_value  = 7,
      bam_dat_i_fifo.almost_empty_value  = 2,
      bam_dat_i_fifo.enable_ecc  = "FALSE",
      bam_dat_i_fifo.intended_device_family  = "Stratix 10",
      bam_dat_i_fifo.lpm_hint  = "RAM_BLOCK_TYPE=MLAB",
      bam_dat_i_fifo.lpm_numwords  = 8,
      bam_dat_i_fifo.lpm_showahead  = "ON",
      bam_dat_i_fifo.lpm_type  = "scfifo",
      bam_dat_i_fifo.lpm_width  = (512),
      bam_dat_i_fifo.lpm_widthu  = 3,
      bam_dat_i_fifo.overflow_checking  = "OFF",
      bam_dat_i_fifo.underflow_checking  = "OFF", 
      bam_dat_i_fifo.use_eab  = "ON";

always_ff @(posedge clk) 
  begin
    srst_reg        <= ~rst_n;
  end 

/// AVMM address masking
always_ff @(posedge clk) 
  if(litem_i_ff_rd)
   begin
    tlp_bar_reg2 <= tlp_bar_reg1;
    tlp_addr_reg2 <= tlp_addr_reg1;
  end

  always_ff @(posedge clk) 
   begin
    tlp_addr_reg3 <= tlp_addr_reg2;
  end

always_comb
  case(tlp_bar_reg2)
      3'b001 : pf0_addr_mask_reg2 = pf0_bar1_address_mask;
      3'b010 : pf0_addr_mask_reg2 = pf0_bar2_address_mask;
      3'b011 : pf0_addr_mask_reg2 = pf0_bar3_address_mask;
      3'b100 : pf0_addr_mask_reg2 = pf0_bar4_address_mask;
      3'b101 : pf0_addr_mask_reg2 = pf0_bar5_address_mask;
      default: pf0_addr_mask_reg2 = pf0_bar0_address_mask;
  endcase

always_ff @(posedge clk) 
    begin
      pf0_addr_mask_reg3[63:0]  <= pf0_addr_mask_reg2[63:0]; 
    end

/// Decoding the downstream Read/Write Header
    assign tlp_len_reg1     = litem_i_hdr_q[9:0];
    assign tlp_hdr_4dw_reg1 = litem_i_hdr_q[29];
    assign tlp_addr_reg1    = tlp_hdr_4dw_reg1 ? {litem_i_hdr_q[95:64], litem_i_hdr_q[127:96]}: {32'h0, litem_i_hdr_q[95:64]};
    assign tlp_pfnum_reg1   = litem_i_hdr_q[129:128];    // bam_rx_func_num_i
    assign tlp_vfnum_reg1   = litem_i_hdr_q[141:130];    // bam_rx_vf_num_i
    assign tlp_vfactive_reg1= litem_i_hdr_q[142];        // bam_rx_vf_active_i
    assign tlp_bar_reg1     = litem_i_hdr_q[145:143];         // rx_bar_i is not used
    // assign tlp_bar_= litem_i_hdr_q[142];        // bam_rx_vf_active_i
    assign tlp_tag_reg1     = litem_i_hdr_q[47:40];
    assign tlp_attr_reg1    = {litem_i_hdr_q[18], litem_i_hdr_q[13:12]};
    assign tlp_tc_reg1      = litem_i_hdr_q[22:20];
    assign tlp_reqid_reg1   = litem_i_hdr_q[63:48];
    // Read of 1DW with fbe=0, is legal from PCIe (could be used as a flush), but this results
    // in a read on AVMM with byte enable = 0. This is illegal in AVMM. So, we convert incoming
    // fbe to 0xF for this case
    assign tlp_fbe_reg1     = flush_rd_reg1 ? 4'hf : litem_i_hdr_q[35:32];
    assign tlp_lbe_reg1     = litem_i_hdr_q[39:36];
    assign tlp_is_wr_reg1   =  litem_i_hdr_q[30] ;
    assign tlp_is_rd_reg1   = ~litem_i_hdr_q[30] ; 
    assign tlp_lbe_zero_reg1 = tlp_lbe_reg1[3:0] == 4'h0;
    assign tlp_dw_size_reg2[9:0]    =  tlp_len_reg1;  // to save registers

    // decode tlp type for decoding flush rd
    assign    rx_fmt     = litem_i_hdr_q[31:29];
    assign    rx_type    = litem_i_hdr_q[28:24];
    assign    mem_rd_tlp = (rx_fmt[1] == 1'b0) && (rx_type == 5'h00) ;
                                   // mem RD       len = 1DW                      fbe = 0
    assign    flush_rd_reg1   = mem_rd_tlp && (tlp_len_reg1 == 10'h1) && (litem_i_hdr_q[35:32] == 4'h0);

  // always @(posedge clk) 
  always_ff @(posedge clk) 
    if (srst_reg) 
      litem_state                   <= LITEM_IDLE;
    else 
      litem_state                   <= litem_nxt_state; 

  always_comb begin
    case(litem_state) 
      LITEM_IDLE:
        if (~litem_i_ff_empty)
          litem_nxt_state  = LITEM_FF_RD;
        else 
          litem_nxt_state  = LITEM_IDLE;
      
      LITEM_FF_RD:
          litem_nxt_state  = LITEM_WAIT_CMD;

      LITEM_WAIT_CMD: /* Previously IDLE */
        if(wrcmd_avail_reg3)
          litem_nxt_state <= LITEM_WR;
        else if(rdcmd_avail_reg3)
          litem_nxt_state <= LITEM_RD;
        else
          litem_nxt_state = LITEM_WAIT_CMD;
          
      LITEM_WR   : 
        if(~lite_master_wait_request_i)
          litem_nxt_state = LITEM_IDLE;
        else 
          litem_nxt_state = LITEM_WR;
      
      LITEM_RD:     
        if(~lite_master_wait_request_i)
          litem_nxt_state = LITEM_WAIT_RDAT;
        else 
          litem_nxt_state = LITEM_RD;
      
       LITEM_WAIT_RDAT: 
        if(lite_master_readdata_valid_i)
          litem_nxt_state = LITEM_CPL;
        else
          litem_nxt_state = LITEM_WAIT_RDAT;
           
       LITEM_CPL:
         if(litem_cpl_ack_i)
            litem_nxt_state <= LITEM_IDLE;
         else
            litem_nxt_state <= LITEM_CPL;
       
       default:
        litem_nxt_state = LITEM_IDLE;
         
    endcase
  end 

logic litem_wrdat_state;
logic litem_iff_rd_state;
logic litem_idle_state;

 assign litem_idle_state      =  (litem_state == LITEM_IDLE);     
 assign litem_wr_state        =  (litem_state == LITEM_WR);     
 assign litem_rd_state        =  (litem_state == LITEM_RD);
 assign litem_cpl_state        =  (litem_state == LITEM_CPL);       
 assign litem_wrdat_state      =  (litem_state == LITEM_WAIT_RDAT);       
 assign litem_iff_rd_state     =  (litem_state == LITEM_FF_RD);       

//// Lite Master state Machine
  // assign litem_i_ff_rd  = (litem_state[1]); 
  assign litem_i_ff_rd  = litem_iff_rd_state; 


always_ff @(posedge clk)  
begin
  if(srst_reg)
    bam_writeresponsevalid_o <= 1'b0;
  else
    bam_writeresponsevalid_o <= (litem_state == LITEM_WR) && 
                                (litem_nxt_state == LITEM_IDLE);
end

// used later for handling the completion when we receive a flush
always_ff @(posedge clk)  
begin
  if(srst_reg)
    cpl_for_flush_rd <= 1'b0;
  else if((litem_state == LITEM_RD) && flush_rd_reg4)
    cpl_for_flush_rd <= 1'b1;
  else if (litem_state == LITEM_IDLE)
    cpl_for_flush_rd <= 1'b0;
end

assign litem_cpl_req_o       = litem_cpl_state;

/// Calculate the AVMM parameters

/// Byte Enable
 always_ff @(posedge clk)  
   begin
     avmm_fbe_reg2[63:0] <= {60'hFFFF_FFFF_FFFF_FFF, tlp_fbe_reg1} << {tlp_addr_reg1[5:2], 2'h0};
     avmm_fbe_reg3[63:0] <= avmm_fbe_reg2[63:0]; 
     avmm_fbe_reg4[63:0] <= avmm_fbe_reg3[63:0];
     // if len = 1DW, incoming lbe would be 0, so we must use fbe for generating the mask
     tlp_lbe_reg2[3:0]   <= (tlp_len_reg1[3:0] == 4'h1) ? tlp_fbe_reg1[3:0] : tlp_lbe_reg1[3:0] ;
    end

 always_ff @(posedge clk) 
      avmm_address_plus_dw_size_reg2[5:0] <= tlp_addr_reg1[5:0] + {tlp_len_reg1[3:0], 2'b00};  

logic [3:0] avmm_lbe_reg3_sel;

assign  avmm_lbe_reg3_sel = avmm_address_plus_dw_size_reg2[5:2];
     always_ff @(posedge clk)  ///  last Tail BE
         // case(avmm_address_plus_dw_size_reg2[5:2])
         case(avmm_lbe_reg3_sel)
///           4'h1: avmm_lbe_reg3[63:0]      <= {56'h0, tlp_lbe_reg2[3:0], { 4{1'b1}}};
///           4'h2: avmm_lbe_reg3[63:0]      <= {52'h0, tlp_lbe_reg2[3:0], { 8{1'b1}}};
///           4'h3: avmm_lbe_reg3[63:0]      <= {48'h0, tlp_lbe_reg2[3:0], {12{1'b1}}}; 
///           4'h4: avmm_lbe_reg3[63:0]      <= {44'h0, tlp_lbe_reg2[3:0], {16{1'b1}}};
///           4'h5: avmm_lbe_reg3[63:0]      <= {40'h0, tlp_lbe_reg2[3:0], {20{1'b1}}};
///           4'h6: avmm_lbe_reg3[63:0]      <= {36'h0, tlp_lbe_reg2[3:0], {24{1'b1}}};
///           4'h7: avmm_lbe_reg3[63:0]      <= {32'h0, tlp_lbe_reg2[3:0], {28{1'b1}}};
///           4'h8: avmm_lbe_reg3[63:0]      <= {28'h0, tlp_lbe_reg2[3:0], {32{1'b1}}};
///           4'h9: avmm_lbe_reg3[63:0]      <= {24'h0, tlp_lbe_reg2[3:0], {36{1'b1}}};
///           4'hA: avmm_lbe_reg3[63:0]      <= {20'h0, tlp_lbe_reg2[3:0], {40{1'b1}}};
///           4'hB: avmm_lbe_reg3[63:0]      <= {16'h0, tlp_lbe_reg2[3:0], {44{1'b1}}};
///           4'hC: avmm_lbe_reg3[63:0]      <= {12'h0, tlp_lbe_reg2[3:0], {48{1'b1}}};
///           4'hD: avmm_lbe_reg3[63:0]      <= { 8'h0, tlp_lbe_reg2[3:0], {52{1'b1}}};
///           4'hE: avmm_lbe_reg3[63:0]      <= { 4'h0, tlp_lbe_reg2[3:0], {56{1'b1}}};
///           4'hF: avmm_lbe_reg3[63:0]      <= {       tlp_lbe_reg2[3:0], {60{1'b1}}};
///           default: avmm_lbe_reg3[63:0]   <= {{64{1'b1}}};     
		   
           4'h1: avmm_lbe_reg3[63:0]      <= {60'h0,                    { 4{1'b1}}};  // F
           4'h2: avmm_lbe_reg3[63:0]      <= {56'h0, tlp_lbe_reg2[3:0], { 4{1'b1}}};
           4'h3: avmm_lbe_reg3[63:0]      <= {52'h0, tlp_lbe_reg2[3:0], { 8{1'b1}}}; 
           4'h4: avmm_lbe_reg3[63:0]      <= {48'h0, tlp_lbe_reg2[3:0], {12{1'b1}}};
           4'h5: avmm_lbe_reg3[63:0]      <= {44'h0, tlp_lbe_reg2[3:0], {16{1'b1}}};
           4'h6: avmm_lbe_reg3[63:0]      <= {40'h0, tlp_lbe_reg2[3:0], {20{1'b1}}};
           4'h7: avmm_lbe_reg3[63:0]      <= {36'h0, tlp_lbe_reg2[3:0], {24{1'b1}}};
           4'h8: avmm_lbe_reg3[63:0]      <= {32'h0, tlp_lbe_reg2[3:0], {28{1'b1}}};
           4'h9: avmm_lbe_reg3[63:0]      <= {28'h0, tlp_lbe_reg2[3:0], {32{1'b1}}};
           4'hA: avmm_lbe_reg3[63:0]      <= {24'h0, tlp_lbe_reg2[3:0], {36{1'b1}}};
           4'hB: avmm_lbe_reg3[63:0]      <= {20'h0, tlp_lbe_reg2[3:0], {40{1'b1}}};
           4'hC: avmm_lbe_reg3[63:0]      <= {16'h0, tlp_lbe_reg2[3:0], {44{1'b1}}};
           4'hD: avmm_lbe_reg3[63:0]      <= {12'h0, tlp_lbe_reg2[3:0], {48{1'b1}}};
           4'hE: avmm_lbe_reg3[63:0]      <= { 8'h0, tlp_lbe_reg2[3:0], {52{1'b1}}};
           4'hF: avmm_lbe_reg3[63:0]      <= { 4'h0, tlp_lbe_reg2[3:0], {56{1'b1}}};		   
           default: avmm_lbe_reg3[63:0]   <= {       tlp_lbe_reg2[3:0], {60{1'b1}}};               
         endcase         

 always_ff @(posedge clk) 
      if(wrcmd_avail_reg3 || rdcmd_avail_reg3) // hold value in case wait req is asserted
        avmm_be_reg4[63:0] <= avmm_fbe_reg3 & avmm_lbe_reg3;  

   always_ff @(posedge clk) 
         avmm_address_reg4[63:0]       <= {tlp_addr_reg3[63:6], 6'h0}  & pf0_addr_mask_reg3;   
// assign avmm_address_reg4[63:0]       = {tlp_addr_reg1[63:6], 6'h0}; /// skip pipe-line register to save area
assign lite_master_address_o[63:0]   = avmm_address_reg4[63:0];

logic [85:0] rd_hdr_reg2;
logic [85:0] rd_hdr_reg3;
/// write/read command available asserted after the bytenables are calculated (4 clocks pipe-line)
  always_ff @(posedge clk)
    begin
   	  flush_rd_reg2  <= litem_i_ff_rd && flush_rd_reg1;
   	  flush_rd_reg3  <= flush_rd_reg2;
   	  flush_rd_reg4  <= flush_rd_reg3;
   	  wrcmd_avail_reg2 <= litem_i_ff_rd & tlp_is_wr_reg1;
   	  wrcmd_avail_reg3 <= wrcmd_avail_reg2;
   	  rdcmd_avail_reg2 <= litem_i_ff_rd & tlp_is_rd_reg1;
   	  rdcmd_avail_reg3 <= rdcmd_avail_reg2;
   	  // reg header for returning completion
	    rd_hdr_reg3      <= rd_hdr_reg2;
	    if (litem_i_ff_rd & tlp_is_rd_reg1)
	      // rd_hdr_reg2    <= {bam_rx_vf_active_i,bam_rx_vf_num_i[11:0],bam_rx_func_num_i[1:0], cpl_lower_addr_i,litem_i_hdr_q[63:0]} ;
        rd_hdr_reg2    <= {tlp_vfactive_reg1,tlp_vfnum_reg1[11:0],tlp_pfnum_reg1[1:0], cpl_lower_addr_i,litem_i_hdr_q[63:0]} ;
    end
   	 
   	assign lite_master_write_o = litem_wr_state; 
   	assign lite_master_wr_byte_enable[63:0] = avmm_be_reg4[63:0];
//   	assign lite_master_rd_byte_enable[63:0] = {64{1'b1}};
//    assign lite_master_byte_enable_o[63:0] = litem_wr_state?  lite_master_wr_byte_enable : lite_master_rd_byte_enable;
    assign lite_master_byte_enable_o[63:0] = lite_master_wr_byte_enable;


/// Lite Master Write Data
    assign data_reg1_dw0 = litem_i_payld_q[31:0]; 
    assign data_reg1_dw1 = litem_i_payld_q[63:32];
    assign data_reg1_dw2 = litem_i_payld_q[95:64];
    assign data_reg1_dw3 = litem_i_payld_q[127:96];
    assign data_reg1_dw4 = litem_i_payld_q[159:128];
    assign data_reg1_dw5 = litem_i_payld_q[191:160];
    assign data_reg1_dw6 = litem_i_payld_q[223:192];
    assign data_reg1_dw7 = litem_i_payld_q[255:224];
    assign data_reg1_dw8 = litem_i_payld_q[287:256];
    assign data_reg1_dw9 = litem_i_payld_q[319:288];
    assign data_reg1_dw10 =litem_i_payld_q[351:320];
    assign data_reg1_dw11 =litem_i_payld_q[383:352];
    assign data_reg1_dw12 =litem_i_payld_q[415:384];
    assign data_reg1_dw13 =litem_i_payld_q[447:416];
    assign data_reg1_dw14 =litem_i_payld_q[479:448];
    assign data_reg1_dw15 =litem_i_payld_q[511:480];

  always_comb  /// Barel Shifter (Coded as muxes in case pipeline is needed)
    case(tlp_addr_reg1[5:2])
       4'h1:
         begin 
          data_mux_out0 <=  32'h0;
          data_mux_out1  <= data_reg1_dw0;  
          data_mux_out2  <= data_reg1_dw1;  
          data_mux_out3  <= data_reg1_dw2;  
          data_mux_out4  <= data_reg1_dw3;  
          data_mux_out5  <= data_reg1_dw4;  
          data_mux_out6  <= data_reg1_dw5;  
          data_mux_out7  <= data_reg1_dw6;  
          data_mux_out8  <= data_reg1_dw7;  
          data_mux_out9  <= data_reg1_dw8;  
          data_mux_out10 <= data_reg1_dw9;  
          data_mux_out11 <= data_reg1_dw10; 
          data_mux_out12 <= data_reg1_dw11; 
          data_mux_out13 <= data_reg1_dw12; 
          data_mux_out14 <= data_reg1_dw13; 
          data_mux_out15 <= data_reg1_dw14;            
        end
        
        
       4'h2:
         begin 
          data_mux_out0 <=  32'h0;
          data_mux_out1  <= 32'h0;  
          data_mux_out2  <= data_reg1_dw0; 
          data_mux_out3  <= data_reg1_dw1; 
          data_mux_out4  <= data_reg1_dw2; 
          data_mux_out5  <= data_reg1_dw3; 
          data_mux_out6  <= data_reg1_dw4; 
          data_mux_out7  <= data_reg1_dw5; 
          data_mux_out8  <= data_reg1_dw6; 
          data_mux_out9  <= data_reg1_dw7; 
          data_mux_out10 <= data_reg1_dw8; 
          data_mux_out11 <= data_reg1_dw9; 
          data_mux_out12 <= data_reg1_dw10;
          data_mux_out13 <= data_reg1_dw11;
          data_mux_out14 <= data_reg1_dw12;
          data_mux_out15 <= data_reg1_dw13;           
        end      
           
      4'h3:
         begin 
          data_mux_out0 <=  32'h0;
          data_mux_out1  <= 32'h0;  
          data_mux_out2  <= 32'h0; 
          data_mux_out3  <= data_reg1_dw0; 
          data_mux_out4  <= data_reg1_dw1; 
          data_mux_out5  <= data_reg1_dw2; 
          data_mux_out6  <= data_reg1_dw3; 
          data_mux_out7  <= data_reg1_dw4; 
          data_mux_out8  <= data_reg1_dw5; 
          data_mux_out9  <= data_reg1_dw6; 
          data_mux_out10 <= data_reg1_dw7; 
          data_mux_out11 <= data_reg1_dw8; 
          data_mux_out12 <= data_reg1_dw9; 
          data_mux_out13 <= data_reg1_dw10;
          data_mux_out14 <= data_reg1_dw11;
          data_mux_out15 <= data_reg1_dw12;          
        end              
           
       4'h4:
         begin 
          data_mux_out0 <=  32'h0;
          data_mux_out1  <= 32'h0;  
          data_mux_out2  <= 32'h0; 
          data_mux_out3  <= 32'h0;
          data_mux_out4  <= data_reg1_dw0; 
          data_mux_out5  <= data_reg1_dw1; 
          data_mux_out6  <= data_reg1_dw2; 
          data_mux_out7  <= data_reg1_dw3; 
          data_mux_out8  <= data_reg1_dw4; 
          data_mux_out9  <= data_reg1_dw5; 
          data_mux_out10 <= data_reg1_dw6; 
          data_mux_out11 <= data_reg1_dw7; 
          data_mux_out12 <= data_reg1_dw8; 
          data_mux_out13 <= data_reg1_dw9; 
          data_mux_out14 <= data_reg1_dw10;
          data_mux_out15 <= data_reg1_dw11;          
        end                 
 
       4'h5:
         begin 
          data_mux_out0 <=  32'h0;
          data_mux_out1  <= 32'h0;  
          data_mux_out2  <= 32'h0; 
          data_mux_out3  <= 32'h0;
          data_mux_out4  <= 32'h0; 
          data_mux_out5  <= data_reg1_dw0; 
          data_mux_out6  <= data_reg1_dw1; 
          data_mux_out7  <= data_reg1_dw2; 
          data_mux_out8  <= data_reg1_dw3; 
          data_mux_out9  <= data_reg1_dw4; 
          data_mux_out10 <= data_reg1_dw5; 
          data_mux_out11 <= data_reg1_dw6; 
          data_mux_out12 <= data_reg1_dw7; 
          data_mux_out13 <= data_reg1_dw8; 
          data_mux_out14 <= data_reg1_dw9; 
          data_mux_out15 <= data_reg1_dw10;          
        end              

       4'h6:
         begin 
          data_mux_out0 <=  32'h0; 
          data_mux_out1  <= 32'h0; 
          data_mux_out2  <= 32'h0; 
          data_mux_out3  <= 32'h0; 
          data_mux_out4  <= 32'h0; 
          data_mux_out5  <= 32'h0; 
          data_mux_out6  <= data_reg1_dw0; 
          data_mux_out7  <= data_reg1_dw1; 
          data_mux_out8  <= data_reg1_dw2; 
          data_mux_out9  <= data_reg1_dw3; 
          data_mux_out10 <= data_reg1_dw4; 
          data_mux_out11 <= data_reg1_dw5; 
          data_mux_out12 <= data_reg1_dw6; 
          data_mux_out13 <= data_reg1_dw7; 
          data_mux_out14 <= data_reg1_dw8; 
          data_mux_out15 <= data_reg1_dw9;           
        end                
 
       4'h7:
         begin 
          data_mux_out0 <=   32'h0;
          data_mux_out1  <=  32'h0;
          data_mux_out2  <=  32'h0;
          data_mux_out3  <=  32'h0;
          data_mux_out4  <=  32'h0;
          data_mux_out5  <=  32'h0;
          data_mux_out6  <=  32'h0;
          data_mux_out7  <=  data_reg1_dw0;     
          data_mux_out8  <=  data_reg1_dw1;     
          data_mux_out9  <=  data_reg1_dw2;     
          data_mux_out10 <=  data_reg1_dw3;     
          data_mux_out11 <=  data_reg1_dw4;     
          data_mux_out12 <=  data_reg1_dw5;     
          data_mux_out13 <=  data_reg1_dw6;     
          data_mux_out14 <=  data_reg1_dw7;     
          data_mux_out15 <=  data_reg1_dw8;          
        end                     
 
       4'h8:
         begin 
          data_mux_out0 <=   32'h0; 
          data_mux_out1  <=  32'h0;    
          data_mux_out2  <=  32'h0;  
          data_mux_out3  <=  32'h0;  
          data_mux_out4  <=  32'h0;  
          data_mux_out5  <=  32'h0;  
          data_mux_out6  <=  32'h0;  
          data_mux_out7  <=  32'h0;  
          data_mux_out8  <=  data_reg1_dw0;       
          data_mux_out9  <=  data_reg1_dw1;       
          data_mux_out10 <=  data_reg1_dw2;       
          data_mux_out11 <=  data_reg1_dw3;       
          data_mux_out12 <=  data_reg1_dw4;       
          data_mux_out13 <=  data_reg1_dw5;       
          data_mux_out14 <=  data_reg1_dw6;       
          data_mux_out15 <=  data_reg1_dw7;          
        end                    

       4'h9:
         begin 
          data_mux_out0  <=  32'h0;
          data_mux_out1  <=  32'h0;     
          data_mux_out2  <=  32'h0;     
          data_mux_out3  <=  32'h0;     
          data_mux_out4  <=  32'h0;     
          data_mux_out5  <=  32'h0;     
          data_mux_out6  <=  32'h0;     
          data_mux_out7  <=  32'h0;     
          data_mux_out8  <=  32'h0;     
          data_mux_out9  <=  data_reg1_dw0;          
          data_mux_out10 <=  data_reg1_dw1;          
          data_mux_out11 <=  data_reg1_dw2;          
          data_mux_out12 <=  data_reg1_dw3;          
          data_mux_out13 <=  data_reg1_dw4;          
          data_mux_out14 <=  data_reg1_dw5;          
          data_mux_out15 <=  data_reg1_dw6;          
        end                         

       4'hA:
         begin 
          data_mux_out0  <=  32'h0;
          data_mux_out1  <=  32'h0;     
          data_mux_out2  <=  32'h0;     
          data_mux_out3  <=  32'h0;     
          data_mux_out4  <=  32'h0;     
          data_mux_out5  <=  32'h0;     
          data_mux_out6  <=  32'h0;     
          data_mux_out7  <=  32'h0;     
          data_mux_out8  <=  32'h0;     
          data_mux_out9  <=  32'h0;     
          data_mux_out10 <=  data_reg1_dw0;          
          data_mux_out11 <=  data_reg1_dw1;          
          data_mux_out12 <=  data_reg1_dw2;          
          data_mux_out13 <=  data_reg1_dw3;          
          data_mux_out14 <=  data_reg1_dw4;          
          data_mux_out15 <=  data_reg1_dw5;          
        end                        

       4'hB:
         begin 
          data_mux_out0  <=  32'h0;
          data_mux_out1  <=  32'h0;      
          data_mux_out2  <=  32'h0;      
          data_mux_out3  <=  32'h0;      
          data_mux_out4  <=  32'h0;      
          data_mux_out5  <=  32'h0;      
          data_mux_out6  <=  32'h0;      
          data_mux_out7  <=  32'h0;      
          data_mux_out8  <=  32'h0;      
          data_mux_out9  <=  32'h0;      
          data_mux_out10 <=  32'h0;      
          data_mux_out11 <=  data_reg1_dw0;           
          data_mux_out12 <=  data_reg1_dw1;           
          data_mux_out13 <=  data_reg1_dw2;           
          data_mux_out14 <=  data_reg1_dw3;           
          data_mux_out15 <=  data_reg1_dw4;           
        end                          
 
       4'hC:
         begin 
          data_mux_out0  <=  32'h0;
          data_mux_out1  <=  32'h0;      
          data_mux_out2  <=  32'h0;      
          data_mux_out3  <=  32'h0;      
          data_mux_out4  <=  32'h0;      
          data_mux_out5  <=  32'h0;      
          data_mux_out6  <=  32'h0;      
          data_mux_out7  <=  32'h0;      
          data_mux_out8  <=  32'h0;      
          data_mux_out9  <=  32'h0;      
          data_mux_out10 <=  32'h0;      
          data_mux_out11 <=  32'h0;      
          data_mux_out12 <=  data_reg1_dw0;           
          data_mux_out13 <=  data_reg1_dw1;           
          data_mux_out14 <=  data_reg1_dw2;           
          data_mux_out15 <=  data_reg1_dw3;           
        end                       
                                                 
       4'hD:
         begin 
          data_mux_out0  <=  32'h0;
          data_mux_out1  <=  32'h0;      
          data_mux_out2  <=  32'h0;      
          data_mux_out3  <=  32'h0;      
          data_mux_out4  <=  32'h0;      
          data_mux_out5  <=  32'h0;      
          data_mux_out6  <=  32'h0;      
          data_mux_out7  <=  32'h0;      
          data_mux_out8  <=  32'h0;      
          data_mux_out9  <=  32'h0;      
          data_mux_out10 <=  32'h0;      
          data_mux_out11 <=  32'h0;      
          data_mux_out12 <=  32'h0;      
          data_mux_out13 <=  data_reg1_dw0;           
          data_mux_out14 <=  data_reg1_dw1;           
          data_mux_out15 <=  data_reg1_dw2;           
        end                         
        
       4'hE:
         begin 
          data_mux_out0  <=   32'h0;
          data_mux_out1  <=   32'h0;     
          data_mux_out2  <=   32'h0;     
          data_mux_out3  <=   32'h0;     
          data_mux_out4  <=   32'h0;     
          data_mux_out5  <=   32'h0;     
          data_mux_out6  <=   32'h0;     
          data_mux_out7  <=   32'h0;     
          data_mux_out8  <=   32'h0;     
          data_mux_out9  <=   32'h0;     
          data_mux_out10 <=   32'h0;     
          data_mux_out11 <=   32'h0;     
          data_mux_out12 <=   32'h0;     
          data_mux_out13 <=   32'h0;     
          data_mux_out14 <=   data_reg1_dw0;          
          data_mux_out15 <=   data_reg1_dw1;          
        end                             
                
    
       4'hF:                                   
         begin                                 
          data_mux_out0  <=  32'h0;
          data_mux_out1  <=  32'h0;      
          data_mux_out2  <=  32'h0;      
          data_mux_out3  <=  32'h0;      
          data_mux_out4  <=  32'h0;      
          data_mux_out5  <=  32'h0;      
          data_mux_out6  <=  32'h0;      
          data_mux_out7  <=  32'h0;      
          data_mux_out8  <=  32'h0;      
          data_mux_out9  <=  32'h0;      
          data_mux_out10 <=  32'h0;      
          data_mux_out11 <=  32'h0;      
          data_mux_out12 <=  32'h0;      
          data_mux_out13 <=  32'h0;      
          data_mux_out14 <=  32'h0;      
          data_mux_out15 <=  data_reg1_dw0;            
        end                                     
                  
       default:
         begin
          data_mux_out0  <=  data_reg1_dw0;    
          data_mux_out1  <=  data_reg1_dw1;
          data_mux_out2  <=  data_reg1_dw2;
          data_mux_out3  <=  data_reg1_dw3;
          data_mux_out4  <=  data_reg1_dw4;
          data_mux_out5  <=  data_reg1_dw5;
          data_mux_out6  <=  data_reg1_dw6;
          data_mux_out7  <=  data_reg1_dw7;
          data_mux_out8  <=  data_reg1_dw8;
          data_mux_out9  <=  data_reg1_dw9;
          data_mux_out10 <=  data_reg1_dw10;
          data_mux_out11 <=  data_reg1_dw11;
          data_mux_out12 <=  data_reg1_dw12;
          data_mux_out13 <=  data_reg1_dw13;
          data_mux_out14 <=  data_reg1_dw14;
          data_mux_out15 <=  data_reg1_dw15;
         end
   endcase

 always_ff  @(posedge clk)
    begin
     data_mux_dw0_reg2  <= data_mux_out0;
     data_mux_dw1_reg2  <= data_mux_out1;
     data_mux_dw2_reg2  <= data_mux_out2;
     data_mux_dw3_reg2  <= data_mux_out3;
     data_mux_dw4_reg2  <= data_mux_out4;
     data_mux_dw5_reg2  <= data_mux_out5;
     data_mux_dw6_reg2  <= data_mux_out6;
     data_mux_dw7_reg2  <= data_mux_out7;
     data_mux_dw8_reg2  <= data_mux_out8;
     data_mux_dw9_reg2  <= data_mux_out9;
     data_mux_dw10_reg2 <= data_mux_out10;
     data_mux_dw11_reg2 <= data_mux_out11;
     data_mux_dw12_reg2 <= data_mux_out12;
     data_mux_dw13_reg2 <= data_mux_out13;
     data_mux_dw14_reg2 <= data_mux_out14;
     data_mux_dw15_reg2 <= data_mux_out15;
    end
       
 always_ff  @(posedge clk) 
    begin
       write_data_reg3 <= {    data_mux_dw15_reg2,data_mux_dw14_reg2,data_mux_dw13_reg2,data_mux_dw12_reg2, 
                               data_mux_dw11_reg2,data_mux_dw10_reg2,data_mux_dw9_reg2,data_mux_dw8_reg2,
                               data_mux_dw7_reg2,data_mux_dw6_reg2,data_mux_dw5_reg2,data_mux_dw4_reg2,
                               data_mux_dw3_reg2,data_mux_dw2_reg2,data_mux_dw1_reg2,data_mux_dw0_reg2};  
      
      if(wrcmd_avail_reg3) // hold value in case wait req is asserted
        write_data_reg4 <=       write_data_reg3;
   end

assign lite_master_write_data_o[511:0] = write_data_reg4;
assign lite_master_burst_count_o[3:0]  =  4'h1;

// hold inputs in case wait req asserted
always_ff @(posedge clk) 
begin
  if (litem_i_ff_rd) 
  begin
   avmm_vfnum_reg4[11:0]   <=   tlp_vfnum_reg1;       
   avmm_pfnum_reg4[1:0]    <=   tlp_pfnum_reg1;        
   avmm_vfactive_reg4      <=   tlp_vfactive_reg1;       
   avmm_bar_reg4[2:0]      <=   tlp_bar_reg1;   
  end
end
  
   assign lite_master_pfnum_o[1:0]    =    avmm_pfnum_reg4[1:0];
   assign lite_master_vfnum_o[11:0]   =    avmm_vfnum_reg4[11:0];
   assign lite_master_vfactive_o      =    avmm_vfactive_reg4;
   assign lite_master_bar_o[2:0]      =    avmm_bar_reg4[2:0];

assign lite_master_read_o = litem_rd_state;

//// Read completion
 always_ff  @(posedge clk)  /// Latch the read data
   if(lite_master_readdata_valid_i)
     litem_cpl_data_reg <= lite_master_readdata_i;

 // assign shiftright_index = {tlp_addr_reg1[5:2],5'h0}; /// bit position shift
 assign shiftright_index = {cpl_lower_addr_wire[5:2],5'h0}; /// bit position shift
 
 assign cpl_data_mux[511:0] = litem_cpl_data_reg[511:0] >> shiftright_index; // optimization needed?
 always_ff @(posedge clk)      
   begin
     tlp_cpl_data_reg[511:0] <=  cpl_data_mux[511:0];
     tlp_cpl_data_reg2[511:0] <=  tlp_cpl_data_reg[511:0];
   end
             
assign litem_cpl_data_o =  tlp_cpl_data_reg2;
/// Completion Header

/// remain bytes [11:0]


always_ff @(posedge clk) 
   casex(cpl_lbe_wire[3:0])
    4'b01xx : last_invalid_bytes_reg2[1:0] <= 2'h1;
    4'b001x : last_invalid_bytes_reg2[1:0] <= 2'h2;
    4'b0001 : last_invalid_bytes_reg2[1:0] <= 2'h3;
    default:  last_invalid_bytes_reg2[1:0] <= 2'h0;     
   endcase

always_ff @(posedge clk)     
    last_invalid_bytes_reg3[1:0] <= last_invalid_bytes_reg2[1:0];


// Use cpl_*
always_ff @(posedge clk) 
   case({cpl_lbe_zero_wire,cpl_fbe_wire[3:0]})
      {1'b1,4'b0001} : first_invalid_bytes_reg2[1:0] <= 2'h3;
      {1'b1,4'b0010} : first_invalid_bytes_reg2[1:0] <= 2'h3;
      {1'b1,4'b0011} : first_invalid_bytes_reg2[1:0] <= 2'h2;
      {1'b1,4'b0100} : first_invalid_bytes_reg2[1:0] <= 2'h3;
      {1'b1,4'b0101} : first_invalid_bytes_reg2[1:0] <= 2'h1;
      {1'b1,4'b0110} : first_invalid_bytes_reg2[1:0] <= 2'h2;
      {1'b1,4'b0111} : first_invalid_bytes_reg2[1:0] <= 2'h1;
      {1'b1,4'b1000} : first_invalid_bytes_reg2[1:0] <= 2'h3;
      {1'b1,4'b1010} : first_invalid_bytes_reg2[1:0] <= 2'h1;
      {1'b1,4'b1100} : first_invalid_bytes_reg2[1:0] <= 2'h2;
      {1'b1,4'b1110} : first_invalid_bytes_reg2[1:0] <= 2'h1;
      {1'b0,4'b0010} : first_invalid_bytes_reg2[1:0] <= 2'h1;  
      {1'b0,4'b0100} : first_invalid_bytes_reg2[1:0] <= 2'h2;  
      {1'b0,4'b0110} : first_invalid_bytes_reg2[1:0] <= 2'h1;  
      {1'b0,4'b1000} : first_invalid_bytes_reg2[1:0] <= 2'h3;  
      {1'b0,4'b1010} : first_invalid_bytes_reg2[1:0] <= 2'h1;  
      {1'b0,4'b1100} : first_invalid_bytes_reg2[1:0] <= 2'h2;  
      {1'b0,4'b1110} : first_invalid_bytes_reg2[1:0] <= 2'h1;  
      default:  first_invalid_bytes_reg2[1:0] <= 2'h0;
    endcase

assign flush_be_reg3 = 1'b0;

 always_ff @(posedge clk) 
   begin
	  total_rd_bytes_reg3[11:0] <= {cpl_len_wire[9:0],2'b00} - first_invalid_bytes_reg2;
      total_rd_bytes_reg4[11:0] <= cpl_for_flush_rd? 12'h1: (total_rd_bytes_reg3[11:0] - last_invalid_bytes_reg3);
   end






   assign cpl_lower_addr_i      = tlp_addr_reg1[6:0];  //Address for registered for read 
                          
   assign cpl_vfactive_wire      =  rd_hdr_reg3[85];
   assign cpl_vfnum_wire         =  rd_hdr_reg3[84:73];
   assign cpl_pfnum_wire         =  rd_hdr_reg3[72:71];
   assign cpl_lower_addr_wire    =  rd_hdr_reg3[70:64];

   assign cpl_len_wire      =  rd_hdr_reg3[9:0];
   assign cpl_attr_wire     =  {rd_hdr_reg3[18], rd_hdr_reg3[13:12]};
   assign cpl_tc_wire       =  rd_hdr_reg3[22:20];                            
   assign cpl_fbe_wire      =  rd_hdr_reg3[35:32];
   assign cpl_lbe_wire      =  rd_hdr_reg3[39:36];
   assign cpl_tag_wire      =  rd_hdr_reg3[47:40];
   assign cpl_reqid_wire    =  rd_hdr_reg3[63:48];                             
   assign cpl_lbe_zero_wire =  cpl_lbe_wire[3:0] == 4'h0;


assign cpl_vfpf[15:0]       = {cpl_vfnum_wire[11:0], 2'b00, cpl_pfnum_wire[1:0]}; 
assign cpl_len[9:0]         = cpl_len_wire;
assign cpl_td_attr[5:0]     = { 1'b0, cpl_attr_wire, 2'b00};
assign cpl_tc[7:0]          = {1'b0, cpl_tc_wire, 4'h0};
assign cpl_cmd[7:0]         = 8'h4A;

assign cpl_byte_count[11:0] = total_rd_bytes_reg4[11:0];
assign cpl_stat_bcm[3:0]    = 4'h0;

 always_ff @(posedge clk) 
   case(cpl_fbe_wire[3:0])
      4'b0010 : lower_addr_offset_reg2[1:0] <= 2'b01;
      4'b0100 : lower_addr_offset_reg2[1:0] <= 2'b10;
      4'b1000 : lower_addr_offset_reg2[1:0] <= 2'b11;
      4'b0110 : lower_addr_offset_reg2[1:0] <= 2'b01;
      4'b1100 : lower_addr_offset_reg2[1:0] <= 2'b10;
      4'b1110 : lower_addr_offset_reg2[1:0] <= 2'b01;
      default:  lower_addr_offset_reg2[1:0] <= 2'b00;
    endcase

 assign cpl_lower_addr_reg2[6:0] = cpl_lower_addr_wire[6:0];
 assign cpl_lower_addr_reg3[6:0] = {cpl_lower_addr_reg2[6:2], lower_addr_offset_reg2[1:0]};
 assign cpl_lower_addr[7:0]      = {1'b0, cpl_lower_addr_reg3[6:0]};
 assign cpl_tag[7:0]             = cpl_tag_wire[7:0];
 assign cpl_reqster_id[15:0]     = cpl_reqid_wire[15:0];
 
 
assign litem_cpl_hdr_o[95:0]     =  { cpl_reqster_id[15:0], cpl_tag[7:0], cpl_lower_addr[7:0],
                                    cpl_vfpf[15:0], cpl_stat_bcm[3:0], cpl_byte_count[11:0],
                                    cpl_cmd[7:0], cpl_tc[7:0], cpl_td_attr[5:0], cpl_len[9:0]};

assign litem_cpl_vfactive_o      = cpl_vfactive_wire;

endmodule

 
