module pcie_ed_dut (
		input  wire         p0_pld_warm_rst_rdy_i,   //   p0_pld_warm_rst_rdy.pld_warm_rst_rdy,  Handshake signal to pld_link_req_rst_o. User asserts pld_warm_rst_rdy_i when application layer is ready for reset. This signal should remain asserted until pld_link_req_rst_o  deasserted or reset_status_n_o asserted.
		output wire         p0_pld_link_req_rst_o,   //     p0_link_req_rst_n.link_req_rst_n,    Asserts when there is a pending hot reset or warm reset request from PCIe Controller. User is expected to perform necessary action in preparation for the reset. User asserts pld_warm_rst_rdy_i in response to pld_link_req_rst_o to allow PCIe Controller to be reset.
		input  wire [2:0]   p0_msi_pnd_func_i,       //                p0_msi.msi_pnd_func,      Check User Guide for details
		input  wire [7:0]   p0_msi_pnd_byte_i,       //                      .msi_pnd_byte,      Check User Guide for details
		input  wire [1:0]   p0_msi_pnd_addr_i,       //                      .msi_pnd_addr,      Check User Guide for details
		input  wire         rx_n_in0,                //            hip_serial.rx_n_in0,          Check User Guide for details
		input  wire         rx_n_in1,                //                      .rx_n_in1,          Check User Guide for details
		input  wire         rx_n_in2,                //                      .rx_n_in2,          Check User Guide for details
		input  wire         rx_n_in3,                //                      .rx_n_in3,          Check User Guide for details
		input  wire         rx_n_in4,                //                      .rx_n_in4,          Check User Guide for details
		input  wire         rx_n_in5,                //                      .rx_n_in5,          Check User Guide for details
		input  wire         rx_n_in6,                //                      .rx_n_in6,          Check User Guide for details
		input  wire         rx_n_in7,                //                      .rx_n_in7,          Check User Guide for details
		input  wire         rx_n_in8,                //                      .rx_n_in8,          Check User Guide for details
		input  wire         rx_n_in9,                //                      .rx_n_in9,          Check User Guide for details
		input  wire         rx_n_in10,               //                      .rx_n_in10,         Check User Guide for details
		input  wire         rx_n_in11,               //                      .rx_n_in11,         Check User Guide for details
		input  wire         rx_n_in12,               //                      .rx_n_in12,         Check User Guide for details
		input  wire         rx_n_in13,               //                      .rx_n_in13,         Check User Guide for details
		input  wire         rx_n_in14,               //                      .rx_n_in14,         Check User Guide for details
		input  wire         rx_n_in15,               //                      .rx_n_in15,         Check User Guide for details
		input  wire         rx_p_in0,                //                      .rx_p_in0,          Check User Guide for details
		input  wire         rx_p_in1,                //                      .rx_p_in1,          Check User Guide for details
		input  wire         rx_p_in2,                //                      .rx_p_in2,          Check User Guide for details
		input  wire         rx_p_in3,                //                      .rx_p_in3,          Check User Guide for details
		input  wire         rx_p_in4,                //                      .rx_p_in4,          Check User Guide for details
		input  wire         rx_p_in5,                //                      .rx_p_in5,          Check User Guide for details
		input  wire         rx_p_in6,                //                      .rx_p_in6,          Check User Guide for details
		input  wire         rx_p_in7,                //                      .rx_p_in7,          Check User Guide for details
		input  wire         rx_p_in8,                //                      .rx_p_in8,          Check User Guide for details
		input  wire         rx_p_in9,                //                      .rx_p_in9,          Check User Guide for details
		input  wire         rx_p_in10,               //                      .rx_p_in10,         Check User Guide for details
		input  wire         rx_p_in11,               //                      .rx_p_in11,         Check User Guide for details
		input  wire         rx_p_in12,               //                      .rx_p_in12,         Check User Guide for details
		input  wire         rx_p_in13,               //                      .rx_p_in13,         Check User Guide for details
		input  wire         rx_p_in14,               //                      .rx_p_in14,         Check User Guide for details
		input  wire         rx_p_in15,               //                      .rx_p_in15,         Check User Guide for details
		output wire         tx_n_out0,               //                      .tx_n_out0,         Check User Guide for details
		output wire         tx_n_out1,               //                      .tx_n_out1,         Check User Guide for details
		output wire         tx_n_out2,               //                      .tx_n_out2,         Check User Guide for details
		output wire         tx_n_out3,               //                      .tx_n_out3,         Check User Guide for details
		output wire         tx_n_out4,               //                      .tx_n_out4,         Check User Guide for details
		output wire         tx_n_out5,               //                      .tx_n_out5,         Check User Guide for details
		output wire         tx_n_out6,               //                      .tx_n_out6,         Check User Guide for details
		output wire         tx_n_out7,               //                      .tx_n_out7,         Check User Guide for details
		output wire         tx_n_out8,               //                      .tx_n_out8,         Check User Guide for details
		output wire         tx_n_out9,               //                      .tx_n_out9,         Check User Guide for details
		output wire         tx_n_out10,              //                      .tx_n_out10,        Check User Guide for details
		output wire         tx_n_out11,              //                      .tx_n_out11,        Check User Guide for details
		output wire         tx_n_out12,              //                      .tx_n_out12,        Check User Guide for details
		output wire         tx_n_out13,              //                      .tx_n_out13,        Check User Guide for details
		output wire         tx_n_out14,              //                      .tx_n_out14,        Check User Guide for details
		output wire         tx_n_out15,              //                      .tx_n_out15,        Check User Guide for details
		output wire         tx_p_out0,               //                      .tx_p_out0,         Check User Guide for details
		output wire         tx_p_out1,               //                      .tx_p_out1,         Check User Guide for details
		output wire         tx_p_out2,               //                      .tx_p_out2,         Check User Guide for details
		output wire         tx_p_out3,               //                      .tx_p_out3,         Check User Guide for details
		output wire         tx_p_out4,               //                      .tx_p_out4,         Check User Guide for details
		output wire         tx_p_out5,               //                      .tx_p_out5,         Check User Guide for details
		output wire         tx_p_out6,               //                      .tx_p_out6,         Check User Guide for details
		output wire         tx_p_out7,               //                      .tx_p_out7,         Check User Guide for details
		output wire         tx_p_out8,               //                      .tx_p_out8,         Check User Guide for details
		output wire         tx_p_out9,               //                      .tx_p_out9,         Check User Guide for details
		output wire         tx_p_out10,              //                      .tx_p_out10,        Check User Guide for details
		output wire         tx_p_out11,              //                      .tx_p_out11,        Check User Guide for details
		output wire         tx_p_out12,              //                      .tx_p_out12,        Check User Guide for details
		output wire         tx_p_out13,              //                      .tx_p_out13,        Check User Guide for details
		output wire         tx_p_out14,              //                      .tx_p_out14,        Check User Guide for details
		output wire         tx_p_out15,              //                      .tx_p_out15,        Check User Guide for details
		output wire         coreclkout_hip,          //        coreclkout_hip.clk,               Check User Guide for details
		input  wire         refclk0,                 //               refclk0.clk,               Check User Guide for details
		input  wire         refclk1,                 //               refclk1.clk,               Check User Guide for details
		input  wire         pin_perst_n,             //             pin_perst.pin_perst,         Check User Guide for details
		input  wire         ninit_done,              //            ninit_done.ninit_done,        Its a Init_done signal should be connected to Reset release IP
		output wire         p0_app_clk,              //            p0_app_clk.clk,               Check User Guide for details
		output wire         p0_reset_status_n,       // p0_app_reset_status_n.reset_n,           Check User Guide for details
		output wire [2:0]   p0_tl_cfg_func_o,        //        p0_config_tl_o.tl_cfg_func,       Check User Guide for details
		output wire [4:0]   p0_tl_cfg_add_o,         //                      .tl_cfg_add,        Check User Guide for details
		output wire [15:0]  p0_tl_cfg_ctl_o,         //                      .tl_cfg_ctl,        Check User Guide for details
		output wire [1:0]   p0_wrdm_pfnum_o,         //       p0_wrdm_conduit.pfnum,             Check User Guide for details
		input  wire         p0_wrdm_waitrequest_i,   //        p0_wrdm_master.waitrequest,       Check User Guide for details
		output wire         p0_wrdm_read_o,          //                      .read,              Check User Guide for details
		output wire [63:0]  p0_wrdm_address_o,       //                      .address,           Check User Guide for details
		output wire [3:0]   p0_wrdm_burstcount_o,    //                      .burstcount,        Check User Guide for details
		output wire [63:0]  p0_wrdm_byteenable_o,    //                      .byteenable,        Check User Guide for details
		input  wire         p0_wrdm_readdatavalid_i, //                      .readdatavalid,     Check User Guide for details
		input  wire [511:0] p0_wrdm_readdata_i,      //                      .readdata,          Check User Guide for details
		input  wire [1:0]   p0_wrdm_response_i,      //                      .response,          Check User Guide for details
		output wire         p0_wrdm_desc_ready_o,    //          p0_wrdm_desc.ready,             Check User Guide for details
		input  wire         p0_wrdm_desc_valid_i,    //                      .valid,             Check User Guide for details
		input  wire [173:0] p0_wrdm_desc_data_i,     //                      .data,              Check User Guide for details
		output wire         p0_wrdm_prio_ready_o,    //          p0_wrdm_prio.ready,             Check User Guide for details
		input  wire         p0_wrdm_prio_valid_i,    //                      .valid,             Check User Guide for details
		input  wire [173:0] p0_wrdm_prio_data_i,     //                      .data,              Check User Guide for details
		output wire         p0_wrdm_tx_valid_o,      //            p0_wrdm_tx.valid,             Check User Guide for details
		output wire [31:0]  p0_wrdm_tx_data_o,       //                      .data,              Check User Guide for details
		output wire [1:0]   p0_rddm_pfnum_o,         //       p0_rddm_conduit.pfnum,             Check User Guide for details
		input  wire         p0_rddm_waitrequest_i,   //        p0_rddm_master.waitrequest,       Check User Guide for details
		output wire         p0_rddm_write_o,         //                      .write,             Check User Guide for details
		output wire [63:0]  p0_rddm_address_o,       //                      .address,           Check User Guide for details
		output wire [3:0]   p0_rddm_burstcount_o,    //                      .burstcount,        Check User Guide for details
		output wire [63:0]  p0_rddm_byteenable_o,    //                      .byteenable,        Check User Guide for details
		output wire [511:0] p0_rddm_writedata_o,     //                      .writedata,         Check User Guide for details
		output wire         p0_rddm_desc_ready_o,    //          p0_rddm_desc.ready,             Check User Guide for details
		input  wire         p0_rddm_desc_valid_i,    //                      .valid,             Check User Guide for details
		input  wire [173:0] p0_rddm_desc_data_i,     //                      .data,              Check User Guide for details
		output wire         p0_rddm_prio_ready_o,    //          p0_rddm_prio.ready,             Check User Guide for details
		input  wire         p0_rddm_prio_valid_i,    //                      .valid,             Check User Guide for details
		input  wire [173:0] p0_rddm_prio_data_i,     //                      .data,              Check User Guide for details
		output wire         p0_rddm_tx_valid_o,      //            p0_rddm_tx.valid,             Check User Guide for details
		output wire [31:0]  p0_rddm_tx_data_o,       //                      .data,              Check User Guide for details
		output wire [1:0]   p0_bam_pfnum_o,          //        p0_bam_conduit.pfnum,             Check User Guide for details
		output wire [2:0]   p0_bam_bar_o,            //                      .barnum,            Check User Guide for details
		input  wire         p0_bam_waitrequest_i,    //         p0_bam_master.waitrequest,       Check User Guide for details
		output wire [63:0]  p0_bam_address_o,        //                      .address,           Check User Guide for details
		output wire [63:0]  p0_bam_byteenable_o,     //                      .byteenable,        Check User Guide for details
		output wire         p0_bam_read_o,           //                      .read,              Check User Guide for details
		input  wire [511:0] p0_bam_readdata_i,       //                      .readdata,          Check User Guide for details
		input  wire         p0_bam_readdatavalid_i,  //                      .readdatavalid,     Check User Guide for details
		output wire         p0_bam_write_o,          //                      .write,             Check User Guide for details
		output wire [511:0] p0_bam_writedata_o,      //                      .writedata,         Check User Guide for details
		output wire [3:0]   p0_bam_burstcount_o,     //                      .burstcount,        Check User Guide for details
		input  wire [1:0]   p0_bam_response_i,       //                      .response,          Check User Guide for details
		output wire [1:0]   p0_bus_master_enable_o   //     p0_bus_master_ena.bus_master_enable, Check User Guide for details
	);
endmodule

