// ============================================================================
// Copyright (c) 2019 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Wed Jun 26 16:32:24 2019
// ============================================================================

//`define ENABLE_DDR4A
//`define ENABLE_DDR4B
//`define ENABLE_FMC
//`define ENABLE_FMCP
//`define ENABLE_HPS
`define ENABLE_PCIE
//`define ENABLE_PCIE_16
module S10_top(

      ///////// CLOCK /////////
      input              CLK_100_B3I,
      input              CLK_50_B2F,
      input              CLK_50_B2L,
      input              CLK_50_B3C,
      input              CLK_50_B3I,
      input              LVDS_REFCLK_p,

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON,

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is Low-Active

`ifdef ENABLE_DDR4A
      ///////// DDR4A /////////
      input              DDR4A_REFCLK_p,
      output   [17: 0]   DDR4A_A,
      output   [ 1: 0]   DDR4A_BA,
      output   [ 1: 0]   DDR4A_BG,
      output             DDR4A_CK,
      output             DDR4A_CK_n,
      output   [ 1: 0]   DDR4A_CKE,
      inout    [ 8: 0]   DDR4A_DQS,
      inout    [ 8: 0]   DDR4A_DQS_n,
      inout    [71: 0]   DDR4A_DQ,
      inout    [ 8: 0]   DDR4A_DBI_n,
      output   [ 1: 0]   DDR4A_CS_n,
      output             DDR4A_RESET_n,
      output   [ 1: 0]   DDR4A_ODT,
      output             DDR4A_PAR,
      input              DDR4A_ALERT_n,
      output             DDR4A_ACT_n,
      input              DDR4A_RZQ,
`endif /*ENABLE_DDR4A*/

`ifdef ENABLE_DDR4B
      ///////// DDR4B /////////
      input              DDR4B_REFCLK_p,
      output   [17: 0]   DDR4B_A,
      output   [ 1: 0]   DDR4B_BA,
      output   [ 1: 0]   DDR4B_BG,
      output             DDR4B_CK,
      output             DDR4B_CK_n,
      output   [ 1: 0]   DDR4B_CKE,
      inout    [ 8: 0]   DDR4B_DQS,
      inout    [ 8: 0]   DDR4B_DQS_n,
      inout    [71: 0]   DDR4B_DQ,
      inout    [ 8: 0]   DDR4B_DBI_n,
      output   [ 1: 0]   DDR4B_CS_n,
      output             DDR4B_RESET_n,
      output   [ 1: 0]   DDR4B_ODT,
      output             DDR4B_PAR,
      input              DDR4B_ALERT_n,
      output             DDR4B_ACT_n,
      input              DDR4B_RZQ,
`endif /*ENABLE_DDR4B*/

      ///////// SI5341A /////////
      inout              SI5341A_I2C_SCL,
      inout              SI5341A_I2C_SDA,
      output             SI5341A_OE_n,
      output             SI5341A_RST_n,

`ifdef ENABLE_FMC
      ///////// FMC /////////
      inout              FMC_CLK2_BIDIR_p,
      inout              FMC_CLK2_BIDIR_n,
      inout              FMC_CLK3_BIDIR_p,
      inout              FMC_CLK3_BIDIR_n,
      inout    [23: 0]   FMC_HA_p,
      inout    [23: 0]   FMC_HA_n,
      inout    [21: 0]   FMC_HB_p,
      inout    [21: 0]   FMC_HB_n,
      inout    [33: 0]   FMC_LA_p,
      inout    [33: 0]   FMC_LA_n,
      input    [ 1: 0]   FMC_CLK_M2C_p,
      input    [ 1: 0]   FMC_GBTCLK_M2C_p,
      input              FMC_REFCLK0_p,
      input              FMC_REFCLK1_p,
      output   [ 9: 0]   FMC_DP_C2M_p,
      input    [ 9: 0]   FMC_DP_M2C_p,
      inout    [ 1: 0]   FMC_GA,
      inout    [ 0: 0]   FMC_RES,
      inout              FMC_SCL,
      inout              FMC_SDA,
`endif /*ENABLE_FMC*/

`ifdef ENABLE_PCIE
      ///////// PCIE /////////
      inout              PCIE_SMBCLK,
      inout              PCIE_SMBDAT,
      input              PCIE_REFCLK_p,
`ifndef ENABLE_PCIE_16
      output   [ 7: 0]   PCIE_TX_p,
      input    [ 7: 0]   PCIE_RX_p,
`else
      output   [15: 0]   PCIE_TX_p,
      input    [15: 0]   PCIE_RX_p,
`endif /*ENABLE_PCIE_16*/
      input              PCIE_PERST_n,
      output             PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/
//`ifdef ENABLE_FMCP
//      ///////// FMCP /////////
//      inout              FMCP_CLK2_BIDIR_p,
//      inout              FMCP_CLK2_BIDIR_n,
//      inout              FMCP_CLK3_BIDIR_p,
//      inout              FMCP_CLK3_BIDIR_n,
//      inout    [23: 0]   FMCP_HA_p,
//      inout    [23: 0]   FMCP_HA_n,
//      inout    [21: 0]   FMCP_HB_p,
//      inout    [21: 0]   FMCP_HB_n,
//      inout    [33: 0]   FMCP_LA_p,
//      inout    [33: 0]   FMCP_LA_n,
//      input    [ 1: 0]   FMCP_CLK_M2C_p,
//      input    [ 4: 0]   FMCP_GBTCLK_M2C_p,
//      input              FMCP_REFCLK0_p,
//      input              FMCP_REFCLK1_p,
//      input              FMCP_REFCLK2_p,
//      output             FMCP_REFCLK_C2M_p,
//      input              FMCP_REFCLK_M2C_p,
//      output   [23: 0]   FMCP_DP_C2M_p,
//      input    [23: 0]   FMCP_DP_M2C_p,
//      inout    [ 1: 0]   FMCP_GA,
//      inout    [ 1: 0]   FMCP_RES,
//      inout              FMCP_SCL,
//      inout              FMCP_SDA,
//      output             FMCP_SYNC_C2M_p,
//      input              FMCP_SYNC_M2C_p,
//`endif /*ENABLE_FMCP*/

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input              HPS_ENET_RX_CTL,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      output             HPS_ENET_TX_CLK,
      output             HPS_ENET_TX_CTL,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      inout    [ 3: 0]   HPS_GPIO,
      inout              HPS_I2C_SCL,
      inout              HPS_I2C_SDA,
      inout              HPS_KEY,
      inout              HPS_LED,
      input              HPS_OSC_CLK,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout    [ 3: 0]   HPS_SD_DATA,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLK,
      inout    [ 7: 0]   HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// S10MAX10 /////////
      output             INFO_SPI_SCLK, 
      output             INFO_SPI_CS_n, 
      output             INFO_SPI_MOSI, 
      input              INFO_SPI_MISO 


);



wire [3:0]   pio_led;
wire [1:0]   pio_button;

wire [31:0] hip_ctrl_test_in;

assign hip_ctrl_test_in = 32'h000000A8;
assign PCIE_WAKE_n = 1'b1;

assign LED[1: 0] = ~pio_led[1:0];// [3: 0]; // led low-active
assign pio_button = ~BUTTON; // button low-active

//////////////////////
// PCIE RESET
wire             any_rstn;
reg              any_rstn_r /* synthesis ALTERA_ATTRIBUTE = "SUPPRESS_DA_RULE_INTERNAL=R102"  */;
reg              any_rstn_rr /* synthesis ALTERA_ATTRIBUTE = "SUPPRESS_DA_RULE_INTERNAL=R102"  */;

assign any_rstn = PCIE_PERST_n & CPU_RESET_n;


//reset Synchronizer
always @(posedge CLK_50_B2F or negedge any_rstn) begin
    if (any_rstn == 0) begin
        any_rstn_r <= 0;
        any_rstn_rr <= 0;
    end else begin
        any_rstn_r <= 1;
        any_rstn_rr <= any_rstn_r;
    end
end

ep_g3x8_avmmdma256_integrated u0 (
    .hip_ctrl_test_in                       (hip_ctrl_test_in),
    //   input,  width = 67,                               .test_in
    .pcie_rstn_npor                         (any_rstn_rr),
    //   input,   width = 1,                      pcie_rstn.npor
    .pcie_rstn_pin_perst                    (PCIE_PERST_n),
    //   input,   width = 1,                               .pin_perst
    .pio_button_external_connection_export  (pio_button),
    //   input,   width = 2, pio_button_external_connection.export
    .pio_led_external_connection_export     (pio_led),
    //  output,   width = 4,    pio_led_external_connection.export
    .refclk_clk                             (PCIE_REFCLK_p),
    //   input,   width = 1,                         refclk.clk
    .xcvr_rx_in0                            (PCIE_RX_p[0]),
    //   input,   width = 1,                           xcvr.rx_in0
    .xcvr_rx_in1                            (PCIE_RX_p[1]),
    //   input,   width = 1,                               .rx_in1
    .xcvr_rx_in2                            (PCIE_RX_p[2]),
    //   input,   width = 1,                               .rx_in2
    .xcvr_rx_in3                            (PCIE_RX_p[3]),
    //   input,   width = 1,                               .rx_in3
    .xcvr_rx_in4                            (PCIE_RX_p[4]),
    //   input,   width = 1,                               .rx_in4
    .xcvr_rx_in5                            (PCIE_RX_p[5]),
    //   input,   width = 1,                               .rx_in5
    .xcvr_rx_in6                            (PCIE_RX_p[6]),
    //   input,   width = 1,                               .rx_in6
    .xcvr_rx_in7                            (PCIE_RX_p[7]),
    //   input,   width = 1,                               .rx_in7
`ifdef ENABLE_PCIE_16
    .xcvr_rx_in8                            (PCIE_RX_p[8]),
    //   input,   width = 1,                               .rx_in8
    .xcvr_rx_in9                            (PCIE_RX_p[9]),
    //   input,   width = 1,                               .rx_in9
    .xcvr_rx_in10                           (PCIE_RX_p[10]),
    //   input,   width = 1,                               .rx_in10
    .xcvr_rx_in11                           (PCIE_RX_p[11]),
    //   input,   width = 1,                               .rx_in11
    .xcvr_rx_in12                           (PCIE_RX_p[12]),
    //   input,   width = 1,                               .rx_in12
    .xcvr_rx_in13                           (PCIE_RX_p[13]),
    //   input,   width = 1,                               .rx_in13
    .xcvr_rx_in14                           (PCIE_RX_p[14]),
    //   input,   width = 1,                               .rx_in14
    .xcvr_rx_in15                           (PCIE_RX_p[15]),
    //   input,   width = 1,                               .rx_in15
`endif
    .xcvr_tx_out0                           (PCIE_TX_p[0]),
    //  output,   width = 1,                               .tx_out0
    .xcvr_tx_out1                           (PCIE_TX_p[1]),
    //  output,   width = 1,                               .tx_out1
    .xcvr_tx_out2                           (PCIE_TX_p[2]),
    //  output,   width = 1,                               .tx_out2
    .xcvr_tx_out3                           (PCIE_TX_p[3]),
    //  output,   width = 1,                               .tx_out3
    .xcvr_tx_out4                           (PCIE_TX_p[4]),
    //  output,   width = 1,                               .tx_out4
    .xcvr_tx_out5                           (PCIE_TX_p[5]),
    //  output,   width = 1,                               .tx_out5
    .xcvr_tx_out6                           (PCIE_TX_p[6]),
    //  output,   width = 1,                               .tx_out6
`ifndef ENABLE_PCIE_16
    .xcvr_tx_out7                           (PCIE_TX_p[7])
    //  output,   width = 1,                               .tx_out7
`else
    .xcvr_tx_out7                           (PCIE_TX_p[7]),
    //  output,   width = 1,                               .tx_out7
    .xcvr_tx_out8                           (PCIE_TX_p[8]),
    //  output,   width = 1,                               .tx_out8
    .xcvr_tx_out9                           (PCIE_TX_p[9]),
    //  output,   width = 1,                               .tx_out9
    .xcvr_tx_out10                          (PCIE_TX_p[10]),
    //  output,   width = 1,                               .tx_out10
    .xcvr_tx_out11                          (PCIE_TX_p[11]),
    //  output,   width = 1,                               .tx_out11
    .xcvr_tx_out12                          (PCIE_TX_p[12]),
    //  output,   width = 1,                               .tx_out12
    .xcvr_tx_out13                          (PCIE_TX_p[13]),
    //  output,   width = 1,                               .tx_out13
    .xcvr_tx_out14                          (PCIE_TX_p[14]),
    //  output,   width = 1,                               .tx_out14
    .xcvr_tx_out15                          (PCIE_TX_p[15])
    //  output,   width = 1,                               .tx_out15
`endif
);

endmodule

